<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Register_driver extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->model('main/admin_model');//TODO
        $this->load->model('config/config_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('setting_model');
        $this->load->library('session');
        $this->load->database();
    }
    function index() {
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        if($this->input->post("register_btn"))
        {
            $this->load->library('form_validation');

            $this->form_validation->set_rules('d_name','نام راننده','required');
            $this->form_validation->set_rules('d_family','نام خانوادگی','required');
            $this->form_validation->set_rules('d_mobile','موبایل','required|numeric|is_unique[_drivers.d_mobile]');
            $this->form_validation->set_rules('d_num_card_driver','شماره هوشمند راننده','required|numeric|is_unique[_drivers.d_num_card_driver]');
            $this->form_validation->set_rules('d_num_card_device','شماره هوشمند خودرو','required|numeric|is_unique[_drivers.d_num_card_device]');
            $this->form_validation->set_rules('reg_accept_rule','شرایط و مقررات','required');

            $this->form_validation->set_message('required', 'وارد کردن فيلد %s الزامي است');
            $this->form_validation->set_message('is_unique', 'اين %s قبلا ثبت شده است');
            $this->form_validation->set_message('numeric', '%s بايد عدد باشد');

            if($this->form_validation->run() != FALSE)
            {
                $data['d_company'] =  "1000";
                $data['d_name'] = $this->input->post("d_name");
                $data['d_family'] = $this->input->post("d_family");
                $data['d_mobile'] = $this->input->post("d_mobile");
                $data['d_mobile_owner'] = $this->input->post("d_mobile_owner");
                $data['d_pelak'] = $this->input->post("d_pelak");
                $data['d_color'] = $this->input->post("d_color");
                $data['d_num_card_driver'] = $this->input->post("d_num_card_driver");
                $data['d_num_card_device'] = $this->input->post("d_num_card_device");
                $data['d_device'] = $this->input->post("d_device");
                $data['d_status'] = $this->input->post("d_status");

                $config['upload_path'] = './images/drivers_img/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('d_image'))
                {
                    $img = $this->upload->data();
                    $data['d_image'] = $img["file_name"];
                }

                if($this->drivers_model->insert($data))
                {
                    $this->send_sms_company_register($data['d_mobile'] , "0000");
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "ثبت نام شما با موفقیت انجام شد از طریق سایت یا لینکی که برای شما ارسال شد اپلیکیشن را دانلود کنید و وارد شوید";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travelcompany/register_driver')); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travelcompany/register_driver')));
                }

            }//end of check form_validation
        }//end of check post register btn

        $where_device["set_kind"] = "device";
        $where_device["set_status"] = "1";
        $data['device'] = $this->setting_model->get('set_id , set_name' , $where_device );

        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view("travelcompany/add_driver_main", $data);



    }//add
    function send_sms_company_register($mobile = '09120917577', $code = '159263') {
        $api_key["apikey"] = "78504F5167616A463741762B656253304A6978535474684E685A715439306E4C";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "verify");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
    }// end of sendSms
    function date_convert($miladi_date)
    {
        error_reporting(0);
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function
    function upload_image($path , $unlink , $image){
        $config['upload_path'] = $path;
        $config['allowed_types'] = 'gif|jpg|png|jpeg';
        $config['encrypt_name'] = 'true';
        $this->load->library('upload',$config);
        if($this->upload->do_upload('image'))
        {
            $img = $this->upload->data();
            if($unlink){
                if(file_exists($path.$image))
                    unlink($path.$image);
            }
            return $img["file_name"];
        }else{
            return false ;
        }
    }// end of upload_image
    function get_cities()
    {
        $this->load->model('travelcompany/city_model');
        $where['province_id'] = $this->input->post('id');
        $res = $this->city_model->get('id , name ', $where);
        if (!empty($res)) {
            foreach ($res as $item)
            {
                $row = array();
                $row["id"] = $item->id;
                $row["name"] = $item->name;
                $jsonData["cities"][] = $row;
            }
        } else {
            $jsonData["status"] = "error";
        }
        echo json_encode($jsonData);
    }//get_cities
    function get_all_cities()
    {
        $this->load->model('travelcompany/city_model');
        $res = $this->city_model->get('id , name ');
        if (!empty($res)) {
            foreach ($res as $item)
            {
                $row = array();
                $row["id"] = $item->id;
                $row["name"] = $item->name;
                $jsonData["cities"][] = $row;
            }
        } else {
            $jsonData["status"] = "error";
        }
        echo json_encode($jsonData);
    }//get_cities

}//end of class