<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Company_model extends CI_Model
{
    function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
    {
        if($select != NULL)
            $this->db->select($select);

        if($where != NULL)
            $this->db->where($where);

        if($order_by != NULL)
            $this->db->order_by($order_by);

        if($group_by != NULL)
            $this->db->group_by($group_by);


        return $this->db->get('_company', $limit, $offset)->result();
    }
    function update($where, $data)
    {
        $this->db->where($where);
        if($this->db->update('_company', $data))
            return TRUE;
        else
            return FALSE;
    }
    function delete($where)
    {
        $this->db->where($where);
        if($this->db->delete('_company'))
            return TRUE;
        else
            return FALSE;
    }
    function insert($data)
    {
        if($this->db->insert('_company', $data))
            return TRUE;
        else
            return FALSE;
    }
    function verify_mobile($verify_code , $mobile)
    {

        $where['cmp_mobile'] = $mobile ;
        $where['cmp_verify_code'] = $verify_code ;
        $data = $this->get("cmp_id",$where);
        if(!empty($data)){
            $where_update['cmp_mobile'] = $mobile ;
            $data_update['cmp_verify_code'] = "0" ;
//            $data_update['cmp_status'] = "1" ;
            if($this->update($where_update, $data_update)){
                return TRUE;
            }else{
                return FALSE;
            }
        }else{
            return FALSE;
        }
    }
    function is_unique($val , $clumn){
        $where[$clumn] = $val;
        $data = $this->get("cmp_id", $where);
        if (empty($data)) {
            return true;
        } else {
            return false;
        }
    }//is_unique
    function get_customer_id($cmp_id){
        $where['cmp_id'] = $cmp_id ;
        $data = $this->get("cmp_customer_id", $where);
        if (empty($data)) {
            return "0";
        } else {
            return $data[0]->cmp_customer_id;
        }
    }//get_customer_id
    function get_code_sms($mobile){
        $where['cmp_mobile'] = $mobile ;
        $data = $this->get("cmp_verify_code", $where);
        if (empty($data)) {
            return "1";
        } else {
            return $data[0]->cmp_verify_code;
        }
    }//get_code_sms
    function get_name_by_id($id)
    {
        if ($id == "1000") {
            return "اپلیکیشن تی درایور";
        } else{
            $where['cmp_id'] = $id;
            $data = $this->get("cmp_name", $where);
            if (!empty($data)) {
                return $data[0]->cmp_name;
            } else {
                return "یافت نشد";
            }
         }
    }
    function get_company_credit($cmp_id){
        $customer_id =  $this->get_customer_id($cmp_id);
        if($customer_id != "0"){
            $cmp_credit = $this->get_credit_api($customer_id);
            return $cmp_credit;
        }else{
            return 0 ;
        }
    }//get_company_credit
    function AbrlineToken(){
        $URL = "https://abrlife.com/api/v2/business/login";
        $data = array('username' => 'tdriver', 'password' => '!@#tdriver.admin');

        $options = array(
            'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data)
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($URL, false, $context);
        if ($result === FALSE) {

            return 0;
        }else{
            $result_json = json_decode($result);
            $code = $result_json->status->code ;
            $description = $result_json->status->description ;
            if($code == 200 && $description == 'success'){
                $id = $result_json->data->business->_id ;
                $token = $result_json->data->token ;
                return $token;
            }else{
                $data = $result_json->data ;
                $out['status'] = "OK";
                $out['message'] = $data;
                return 0;
            }
        }
    }//Abrlife_login
    function get_credit_api($customer_id){

        $Authorization = $this->AbrlineToken();
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/userbalance?customer_id=".$customer_id,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Postman-Token: 87c7ac57-c5aa-41df-9090-66ae7083e20c",
                "cache-control: no-cache"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return false ;
        } else {
//            var_dump($response);
            $result_json = json_decode($response);
            $status = $result_json->status->description;
            if($status == "success"){
                $credit = $result_json->data;
                return $credit;
            }else{
                return "ERR" ;
            }

        }
    }//get_credit_api
    function company_tasvieh($customer_id , $amount){

        $Authorization = $this->AbrlineToken();
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/userwithdraw",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => "{\n\t\"customer_id\":\"$customer_id\",\n\t\"amount\":\"$amount\"\n}",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Content-Type: application/json",
                "Postman-Token: 732dc300-8720-42e5-a811-0f2255878c0f",
                "cache-control: no-cache"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            $jsonData['status'] = "error";
            $jsonData['message'] = $err;
        } else {
            $result_json = json_decode($response);
            $status = $result_json->status->description;
            if($status == "success"){
                return "OK" ;
            }
            else{
                return $result_json->data;
            }
        }
        echo json_encode($jsonData);
    }//company_tasvieh
}//end of class