<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Admin extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		$this->load->helper('form');
		$this->load->helper('url');
		$this->load->model('main/admin_model');//TODO
		$this->load->library('session');
		$this->load->database(); 
	}

	function index()
	{
		
        $this->check_login();
        $this->load->library('pagination');
			
		if($this->input->get('search'))
		{
				$like['admin_name'] =  $this->to_utf8($this->input->get('search'));
				$like['admin_mobile'] =$this->to_utf8($this->input->get('search'));
				$like['admin_email'] =$this->to_utf8($this->input->get('search'));
				$config['per_page'] = NULL;
				$data['pagination'] = NULL;
				$data['content'] = $this->admin_model->get('*', NULL, NULL , NULL , NULL , NULL , $like );
		}
		else{
			 $like = NULL ;

			$this->load->library('pagination');

			$config['base_url'] = site_url(array('admin','index'));//TODO
			$config['total_rows'] = sizeof($this->admin_model->get('admin_id'));//TODO
			$config['per_page'] = 15; 
			$config['uri_segment'] = 3;
			$config['first_link'] = '&#1575;&#1608;&#1604;&#1740;&#1606;';
			$config['last_link'] = '&#1570;&#1582;&#1585;&#1740;&#1606;';
			$config['next_link'] = '&#1576;&#1593;&#1583;&#1740;';
			$config['prev_link'] = '&#1602;&#1576;&#1604;&#1740;';
			$config['full_tag_open'] = '<ul class="pagination">';
			$config['full_tag_close'] = '</ul>';
			$config['first_tag_open'] = '<li>';
			$config['first_tag_close'] = '</li>';
			$config['last_tag_open'] = '<li>';
			$config['last_tag_close'] = '</li>';
			$config['num_tag_open'] = '<li>';
			$config['num_tag_close'] = '</li>';
			$config['cur_tag_open'] = '<li class="active"><a href="">';
			$config['cur_tag_close'] = '</a></li>';
			$config['next_tag_open'] = '<li class="next">';
			$config['next_tag_close'] = '</li>';
			$config['prev_tag_open'] = '<li class="prev">';
			$config['prev_tag_close'] = '</li>';

			$this->pagination->initialize($config);
			$data['pagination'] = $this->pagination->create_links();
			$data['content'] = $this->admin_model->get('*', NULL, $config['per_page'], $this->uri->segment(3) , $like );

		}
			

			foreach ($data['content'] as $item)
			{
				if($item->admin_status == "0")
					$item->admin_status = "غیر فعال";
				elseif($item->admin_status == "1")
					$item->admin_status = "فعال";
				elseif($item->admin_status == "2")
					$item->admin_status = "مسدود شده";

        $item->admin_last_login = $this->date_convert($item->admin_last_login);
        $item->admin_date_create = $this->date_convert($item->admin_date_create);
        $item->admin_last_edit = $this->date_convert($item->admin_last_edit);

        $where_user_add['admin_id'] = $item->admin_create_by;
        if($item->admin_create_by == "0")
          $item->admin_create_by = "نا مشخص";
        else
          $item->admin_create_by = $this->admin_model->get_user_name_by_id($where_user_add);

        $where_user_edit['admin_id'] = $item->admin_edit_by;
        if($item->admin_edit_by == "0")
          $item->admin_edit_by = "نا مشخص";
        else
          $item->admin_edit_by = $this->admin_model->get_user_name_by_id($where_user_edit);

			}

			$data['sidebar'] = $this->load->view("side_bar", "", TRUE);
			$this->load->view("base/admin_list", $data);
	}//end of index function
	
	
	


  function add()
  {
    $this->check_login();
    if($this->input->post("register_btn"))
    {
      $this->load->library('form_validation');
      $this->form_validation->set_rules('admin_name','نام','required');
      $this->form_validation->set_rules('admin_mobile','موبایل','required');
      $this->form_validation->set_rules('admin_email','ایمیل','required');
      $this->form_validation->set_rules('admin_password','رمز عبور','required');
      $this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است');
      if($this->form_validation->run() != FALSE)
      {
        $data['admin_name'] = $this->input->post("admin_name");
        $data['admin_mobile'] = $this->input->post("admin_mobile");
        $data['admin_email'] = $this->input->post("admin_email");
        $data['admin_status'] = $this->input->post("admin_status");
        $data['admin_password'] = md5($this->input->post("admin_password"));
        $data['admin_level'] = "1";
        $data['admin_create_by'] = $this->session->userdata("admin_id");

        $path = './images/admin/';
        $result_upload =  $this->upload_image($path , false , "");
        if($result_upload !== false ){
          $data['admin_image'] = $result_upload;
        }

        if($this->admin_model->insert($data)) //TODO
        {
          $msg['msg'][0] = 'success';
          $msg['msg'][1] = "با موفقیت اضافه شد";
          $this->session->set_flashdata($msg);
          redirect(site_url(array('base/admin')));//TODO
        }
        else
        {
          $msg['msg'][0] = "danger";
          $msg['msg'][1] = "خطا دوباره امتحان کنید";
          $this->session->set_flashdata($msg);
          redirect(site_url(array('base/admin')));//TODO
        }

      }//end of check form_validation
    }//end of check post register btn

    $data['sidebar'] = $this->load->view("side_bar", "", TRUE);//TODO
    $this->load->view("base/add/add_admin", $data);//TODO
  }//end of add function


  function edit()
  {
    $this->check_login();

    $where['admin_id'] = $this->uri->segment(4);
    if(!is_numeric($where['admin_id']))
    {
      $msg['msg'][0] = "danger";
      $msg['msg'][1] = "آیدی اشتباه است";
      $this->session->set_flashdata($msg);
      redirect(site_url('base/admin'));
    }

    $data['content'] = $this->admin_model->get('*', $where );
    if ($data['content'][0]->admin_image == "-1")
      $data['content'][0]->admin_image = "img_blank" ;

    if(empty($data['content']))
    {
      $msg['msg'][0] = "danger";
      $msg['msg'][1] = "چنین ادمینی وجود ندارد";
      $this->session->set_flashdata($msg);
      redirect(site_url('base/admin'));
    }

    if($this->input->post("edit_btn"))
    {
      $this->load->library('form_validation');
      $this->form_validation->set_rules('admin_name','نام','required');
      $this->form_validation->set_rules('admin_mobile','موبایل','required');
      $this->form_validation->set_rules('admin_email','ایمیل','required');
      $this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است');
      if($this->form_validation->run() != FALSE)
      {

        $data_edit['admin_name'] = $this->input->post("admin_name");
        $data_edit['admin_mobile'] = $this->input->post("admin_mobile");
        $data_edit['admin_email'] = $this->input->post("admin_email");
        $data_edit['admin_status'] = $this->input->post("admin_status");
        $data_edit['admin_password'] = md5($this->input->post("admin_password"));
        $data_edit['admin_level'] = "1";
        $data_edit['admin_edit_by'] = $this->session->userdata("admin_id");
        $data_edit['admin_last_edit'] = date("Y-m-d H:i:s");


        $unlink = false ;
        if($data['content'][0]->admin_image != NULL && $data['content'][0]->admin_image != '-1')
          $unlink = true ;
        $path = './images/admin/';
        $result_upload =  $this->upload_image($path , $unlink , $data['content'][0]->admin_image);
        if($result_upload !== false ){
          $data_edit['admin_image'] = $result_upload;
        }

        if($this->admin_model->update($where, $data_edit))
        {
          $msg['msg'][0] = 'success';
          $msg['msg'][1] = "ویرایش با موفقیت انجام شد";
          $this->session->set_flashdata($msg);
          redirect(site_url('base/admin'));
        }
        else
        {
          $msg['msg'][0] = "danger";
          $msg['msg'][1] = "خطا دوباره امتحان کنید";
          $this->session->set_flashdata($msg);
          redirect(site_url('base/admin'));
        }


      }//end of check form_validation

    }//end of check post edit btn


    $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
    $this->load->view("base/edit/edit_admin", $data);

  }//end of edit function


  function date_convert($miladi_date)
  {
    error_reporting(0);
    $this->load->library('jdf');
    $explode_date_time = explode(" ", $miladi_date);
    $explode_date = explode("-", $explode_date_time[0]);
    return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
  }//end of date_convert function


  function upload_image($path , $unlink , $image){
    $this->check_login();
    $config['upload_path'] = $path;
    $config['allowed_types'] = 'gif|jpg|png|jpeg';
    $config['encrypt_name'] = 'true';
    $this->load->library('upload',$config);
    if($this->upload->do_upload('image'))
    {
      $img = $this->upload->data();
      if($unlink){
        if(file_exists($path.$image))
          unlink($path.$image);
      }
      return $img["file_name"];
    }else{
      return false ;
    }
  }// end of upload_image


  function check_login()
  {
    if(!$this->session->userdata("admin_id"))
    {
      redirect(site_url('base/log_in'));
    }
  }//end of check_login function


}//end of class