<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Drivers extends CI_Controller {
    function __construct() {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->library('session');
        $this->load->database();
        $this->load->model('config/config_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('setting_model');
    }

    function index() {
        $this->config_model->check_login("ADMIN");

        $like = NULL ;
        $this->load->library('pagination');
        $where['d_status !='] = "3" ;
        $config['base_url'] = site_url(array('travelcompany/drivers','index'));
        $config['total_rows'] = sizeof($this->drivers_model->get('d_id' , $where ));
        $config['per_page'] = 20;
        $config['uri_segment'] = 4;
        $config['first_link'] = '&#1575;&#1608;&#1604;&#1740;&#1606;';
        $config['last_link'] = '&#1570;&#1582;&#1585;&#1740;&#1606;';
        $config['next_link'] = '&#1576;&#1593;&#1583;&#1740;';
        $config['prev_link'] = '&#1602;&#1576;&#1604;&#1740;';
        $config['full_tag_open'] = '<ul class="pagination">';
        $config['full_tag_close'] = '</ul>';
        $config['first_tag_open'] = '<li>';
        $config['first_tag_close'] = '</li>';
        $config['last_tag_open'] = '<li>';
        $config['last_tag_close'] = '</li>';
        $config['num_tag_open'] = '<li>';
        $config['num_tag_close'] = '</li>';
        $config['cur_tag_open'] = '<li class="active"><a href="">';
        $config['cur_tag_close'] = '</a></li>';
        $config['next_tag_open'] = '<li class="next">';
        $config['next_tag_close'] = '</li>';
        $config['prev_tag_open'] = '<li class="prev">';
        $config['prev_tag_close'] = '</li>';

        $this->pagination->initialize($config);
        $data['pagination'] = $this->pagination->create_links();

        $where_get['d_status !='] = "3" ;
        $data['content'] = $this->drivers_model->get("*",$where_get);
        foreach ($data['content'] as $item){
            if($item->d_status == "0"){
                $item->d_status = "غیر فعال";
            }
            else if($item->d_status == "1"){
                $item->d_status = " فعال";
            }
            else if($item->d_status == "2"){
                $item->d_status = "مسدود";
            }

            $item->d_device = $this->setting_model->get_device_kind($item->d_device);
            $item->d_company = $this->company_model->get_name_by_id($item->d_company);

        }




        $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
        $this->load->view('drivers_list', $data);
    }//end of index function


    function add() {
        $this->config_model->check_login("COMPANY");
        if($this->input->post("register_btn"))
        {
            $this->load->library('form_validation');

            $this->form_validation->set_rules('d_name','نام راننده','required');
            $this->form_validation->set_rules('d_family','نام خانوادگی','required');
            $this->form_validation->set_rules('d_mobile','موبایل','required|numeric|is_unique[_drivers.d_mobile]');
            $this->form_validation->set_rules('d_num_card_driver','شماره هوشمند راننده','required|numeric|is_unique[_drivers.d_num_card_driver]');
            $this->form_validation->set_rules('d_num_card_device','شماره هوشمند خودرو','required|numeric|is_unique[_drivers.d_num_card_device]');

            $this->form_validation->set_message('required', 'وارد کردن فيلد %s الزامي است');
            $this->form_validation->set_message('is_unique', 'اين %s قبلا ثبت شده است');
            $this->form_validation->set_message('numeric', '%s بايد عدد باشد');

            if($this->form_validation->run() != FALSE)
            {
                $data['d_company'] =  $this->session->userdata("cmp_id");
                $data['d_name'] = $this->input->post("d_name");
                $data['d_family'] = $this->input->post("d_family");
                $data['d_mobile'] = $this->input->post("d_mobile");
                $data['d_mobile_owner'] = $this->input->post("d_mobile_owner");
                $data['d_pelak'] = $this->input->post("d_pelak");
                $data['d_color'] = $this->input->post("d_color");
                $data['d_num_card_driver'] = $this->input->post("d_num_card_driver");
                $data['d_num_card_device'] = $this->input->post("d_num_card_device");
                $data['d_device'] = $this->input->post("d_device");
                $data['d_status'] = $this->input->post("d_status");

                $config['upload_path'] = './images/drivers_img/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('d_image'))
                {
                    $img = $this->upload->data();
                    $data['d_image'] = $img["file_name"];
                }

                if($this->drivers_model->insert($data))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travelcompany/drivers')); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travelcompany/drivers', 'add')));
                }

            }//end of check form_validation
        }//end of check post register btn

        $where_device["set_kind"] = "device";
        $where_device["set_status"] = "1";
        $data['device'] = $this->setting_model->get('set_id , set_name' , $where_device );

        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view("travelcompany/add_driver", $data);



    }//add


    function edit() {
        $this->config_model->check_login("ADMIN");
        $where['d_id'] = $this->uri->segment(3);
        $data['content'] = $this->drivers_model->get("*", $where);
        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "یافت نشد !";
            $this->session->set_flashdata($msg);
            redirect(site_url('drivers')); // TODO
        }

        if($this->input->post("btn_edit"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('d_name','نام راننده','required');
            $this->form_validation->set_rules('d_family','نام خانوادگی','required');
            $this->form_validation->set_rules('d_mobile','موبایل','required');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {
                $data_update['d_name'] = $this->input->post("d_name");
                $data_update['d_family'] = $this->input->post("d_family");
                $data_update['d_mobile'] = $this->input->post("d_mobile");
                $data_update['d_mobile_owner'] = $this->input->post("d_mobile_owner");
                $data_update['d_pelak'] = $this->input->post("d_pelak");
                $data_update['d_color'] = $this->input->post("d_color");
                $data_update['d_num_card_driver'] = $this->input->post("d_num_card_driver");
                $data_update['d_num_card_device'] = $this->input->post("d_num_card_device");
                $data_update['d_device'] = $this->input->post("d_device");
                $data_update['d_status'] = $this->input->post("d_status");

                $config['upload_path'] = './images/drivers_img/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('d_image'))
                {
                    $img = $this->upload->data();
                    $data_update['d_image'] = $img["file_name"];
                }

                if($this->drivers_model->update($where , $data_update))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('drivers')); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('drivers', 'edit')));
                }

            }//end of check form_validation
        }//end of check post register btn

        $where_device["set_kind"] = "device";
        $where_device["set_status"] = "1";
        $data['device'] = $this->setting_model->get('set_id , set_name' , $where_device );

        $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
        $this->load->view("edit_driver", $data);



    }//edit



    function delete() {
        $where['d_id'] = $this->uri->segment(3);
        if(!is_numeric($where['d_id']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "شمارنده یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('drivers')); // TODO
        }

        $data['content'] = $this->drivers_model->get("*", $where);
        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "مشخصات یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('drivers')); // TODO
        }

        $data_update['d_status'] = "3";
        $data_update['d_mobile'] = NULL;
        $data_update['d_mobile_owner'] = NULL;
        $data_update['d_firebase_code'] = NULL;
        $data_update['d_num_card_driver'] = NULL;
        $data_update['d_num_card_device'] = NULL;
        if($this->drivers_model->update($where , $data_update)){
            $msg['msg'][0] = 'success';
            $msg['msg'][1] = "با موفقیت پاک شد.";
            $this->session->set_flashdata($msg);
            redirect(site_url('drivers')); // TODO
        }
        else
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "خطا در ثبت اطلاعات";
            $this->session->set_flashdata($msg);
            redirect(site_url('drivers')); // TODO
        }
    }//delete



}//end of class
