<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
date_default_timezone_set('Asia/Tehran');


class Webservice extends CI_Controller {


    function __construct() {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->library('session');
        $this->load->database();
    }

    function index() {

    }//end of index function

    function search_parsijo_map(){

        $jsonData["address"] = array();
        $Searchkey = $this->input->get('Searchkey');
        $CityName = "یاسوج";

        $URL = "https://developers.parsijoo.ir/web-service/v1/map/?type=search&q=".$Searchkey."&page=1&nrpp=10&city=".$CityName;
;

        $opts = [
            "http" => [
                "method" => "GET",
                "header" => "api-key: 5fc16a18cdc444c3b28996ea1fc7198f"
            ]
        ];

        $context = stream_context_create($opts);
        $file = @file_get_contents($URL, false, $context);
        $json = json_decode($file);
        $statusCode = $json->reqStatus->statusCode;
        if($statusCode == 200){
            $jsonData['status'] = "OK";
            $resultNumber = $json->result->resultNumber;
            for($i=0 ; $i<$resultNumber ; $i++){
                $row = array();
                $row["title"] = $json->result->items[$i]->title;
                $row["lat"] = $json->result->items[$i]->latitude;
                $row["lng"] = $json->result->items[$i]->longitude;
                $row["zoom"] = $json->result->items[$i]->zoom;
                $jsonData["address"][] = $row;
            }//for
        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = $json->reqStatus->message;
        }

        echo json_encode($jsonData);

    }//search_parsijo_map


    function get_address(){
            $lat = $this->input->post('lat');
            $lng = $this->input->post('lng');
            $URL = "https://developers.parsijoo.ir/web-service/v1/map/?type=address&x=".$lng."&y=".$lat;

            $opts = [
                "http" => [
                    "method" => "GET",
                    "header" => "api-key: 5fc16a18cdc444c3b28996ea1fc7198f"
                ]
            ];

            $context = stream_context_create($opts);
            $file = @file_get_contents($URL, false, $context);
            $json = json_decode($file);
            $status = $json->reqStatus->statusCode;
            $ways= $json->result->ways;

            if($status == "200") {
                $jsonData['status'] = "OK";
                $jsonData['address'] = $ways;
            }else {
                $jsonData['status'] = "error";
                $jsonData['message'] = $status;
            }
              echo json_encode($jsonData);

    }

    function distance_time(){
        $lat1 = $this->input->post('lat1');
        $lng1 = $this->input->post('lng1');
        $lat2 = $this->input->post('lat2');
        $lng2 = $this->input->post('lng2');
        $distance = $this->haversineGreatCircleDistance($lat1,$lng1,$lat2,$lng2);
        $jsonData['status'] = "OK";
        $jsonData['distance'] = (int) $distance . " متر ";
        $jsonData['time'] = (int) ( ($distance * 20)/4000) . " دقیقه ";
        echo json_encode($jsonData);


    }//distance_time

    function haversineGreatCircleDistance(
        $latitudeFrom, $longitudeFrom, $latitudeTo, $longitudeTo, $earthRadius = 6371000)
    {
        // convert from degrees to radians
        $latFrom = deg2rad($latitudeFrom);
        $lonFrom = deg2rad($longitudeFrom);
        $latTo = deg2rad($latitudeTo);
        $lonTo = deg2rad($longitudeTo);

        $latDelta = $latTo - $latFrom;
        $lonDelta = $lonTo - $lonFrom;

        $angle = 2 * asin(sqrt(pow(sin($latDelta / 2), 2) +
                cos($latFrom) * cos($latTo) * pow(sin($lonDelta / 2), 2)));
        return $angle * $earthRadius;
    }




}//end of class
