<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Travel_company extends CI_Controller {
  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->load->model('config/config_model');
      $this->load->model('travelcompany/company_model');
      $this->load->model('travelcompany/city_model');
  }

  function index() {
    $this->config_model->check_login("COMPANY");

      $like = NULL ;
      $where['cmp_status !='] = "3";
      $this->load->library('pagination');
      $config['base_url'] = site_url(array('travelcompany','index'));
      $config['total_rows'] = sizeof($this->company_model->get('cmp_id' , $where));
      $config['per_page'] = 20;
      $config['uri_segment'] = 4;
      $config['first_link'] = '&#1575;&#1608;&#1604;&#1740;&#1606;';
      $config['last_link'] = '&#1570;&#1582;&#1585;&#1740;&#1606;';
      $config['next_link'] = '&#1576;&#1593;&#1583;&#1740;';
      $config['prev_link'] = '&#1602;&#1576;&#1604;&#1740;';
      $config['full_tag_open'] = '<ul class="pagination">';
      $config['full_tag_close'] = '</ul>';
      $config['first_tag_open'] = '<li>';
      $config['first_tag_close'] = '</li>';
      $config['last_tag_open'] = '<li>';
      $config['last_tag_close'] = '</li>';
      $config['num_tag_open'] = '<li>';
      $config['num_tag_close'] = '</li>';
      $config['cur_tag_open'] = '<li class="active"><a href="">';
      $config['cur_tag_close'] = '</a></li>';
      $config['next_tag_open'] = '<li class="next">';
      $config['next_tag_close'] = '</li>';
      $config['prev_tag_open'] = '<li class="prev">';
      $config['prev_tag_close'] = '</li>';

      $this->pagination->initialize($config);
      $data['pagination'] = $this->pagination->create_links();
      $data['content'] = $this->company_model->get("*" , $where);


      foreach ($data['content'] as $item){
          $item->cmp_province = $this->city_model->get_province_name($item->cmp_province);
          $item->cmp_city = $this->city_model->get_city_name($item->cmp_city);


          switch ($item->cmp_status){
              case "0":
                  $item->cmp_status = "غیر فعال";
                  break;
              case "1":
                  $item->cmp_status = " فعال";
                  break;
              case "2":
                  $item->cmp_status = "مسدود شده";
                  break;
          }//switch
      }



      $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
      $this->load->view('company_list', $data);
  }//end of index function


    function edit() {

        $this->config_model->check_login("COMPANY");
        $where['cmp_id'] = $this->uri->segment(3);

        if(!is_numeric($where['cmp_id']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "شماره یافت نشد ";
            $this->session->set_flashdata($msg);
            redirect(site_url('travel_company'));
        }
        $data['content'] = $this->company_model->get('*', $where);

        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "اطلاعات یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('travel_company'));
        }

        if($this->input->post("edit_btn"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('cmp_name','نام شرکت','required');
            $this->form_validation->set_rules('cmp_type','cmp_type','required');
            $this->form_validation->set_rules('cmp_kind','cmp_kind','required');
            $this->form_validation->set_rules('cmp_management','','required');
            $this->form_validation->set_rules('cmp_phone','','required');
            $this->form_validation->set_rules('cmp_mobile','','required');
            $this->form_validation->set_rules('cmp_province','','required');
            $this->form_validation->set_rules('cmp_city','','required');
            $this->form_validation->set_rules('cmp_username','','required');
            $this->form_validation->set_rules('cmp_password','','required');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {
                $data_new['cmp_name'] = $this->input->post("cmp_name");
                $data_new['cmp_type'] = $this->input->post("cmp_type");
                $data_new['cmp_kind'] = $this->input->post("cmp_kind");
                $data_new['cmp_management'] = $this->input->post("cmp_management");
                $data_new['cmp_phone'] = $this->input->post("cmp_phone");
                $data_new['cmp_mobile'] = $this->input->post("cmp_mobile");
                $data_new['cmp_fax'] = $this->input->post("cmp_fax");
                $data_new['cmp_province'] = $this->input->post("cmp_province");
                $data_new['cmp_city'] = $this->input->post("cmp_city");
//                $data_new['cmp_code'] = $this->input->post("cmp_code");
                $data_new['cmp_melli_code'] = $this->input->post("cmp_melli_code");
                $data_new['cmp_economy_code'] = $this->input->post("cmp_economy_code");
                $data_new['cmp_username'] = $this->input->post("cmp_username");
                $data_new['cmp_password'] = $this->input->post("cmp_password");

                $config['upload_path'] = './images/company/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('image'))
                {
                    $img = $this->upload->data();
                    $data_new['cmp_image'] = $img["file_name"];
                }

                if($this->company_model->update($where, $data_new))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ویرایش شد";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travel_company'));
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travel_company', 'add', $data['content'][0]->cmp_id)));

                }

            }//end of check form_validation
        }//end of check post edit btn


        $data['province'] = $this->city_model->get_province('*');
        $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
        $this->load->view("edit_company", $data);



    }//edit


    function edit_admin() {

        $sms = false ;
        $this->config_model->check_login("COMPANY");
        $where['cmp_id'] = $this->uri->segment(3);

        if(!is_numeric($where['cmp_id']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "شماره یافت نشد ";
            $this->session->set_flashdata($msg);
            redirect(site_url('travel_company'));
        }
        $data['content'] = $this->company_model->get('*', $where);

        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "اطلاعات یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('travel_company'));
        }

        if($this->input->post("edit_btn"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('cmp_name','نام شرکت','required');
            $this->form_validation->set_rules('cmp_type','cmp_type','required');
            $this->form_validation->set_rules('cmp_kind','cmp_kind','required');
            $this->form_validation->set_rules('cmp_management','','required');
            $this->form_validation->set_rules('cmp_phone','','required');
            $this->form_validation->set_rules('cmp_mobile','','required');
            $this->form_validation->set_rules('cmp_province','','required');
//            $this->form_validation->set_rules('cmp_city','','required');
            $this->form_validation->set_rules('cmp_username','','required');
            $this->form_validation->set_rules('cmp_password','','required');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {

                if($data['content'][0]->cmp_status == "0" && $this->input->post("cmp_status") == "1"){
                    $sms = true;
                }

                $data_new['cmp_shaba'] = $this->input->post("cmp_shaba");
                $data_new['cmp_name'] = $this->input->post("cmp_name");
                $data_new['cmp_type'] = $this->input->post("cmp_type");
                $data_new['cmp_kind'] = $this->input->post("cmp_kind");
                $data_new['cmp_management'] = $this->input->post("cmp_management");
                $data_new['cmp_phone'] = $this->input->post("cmp_phone");
                $data_new['cmp_mobile'] = $this->input->post("cmp_mobile");
                $data_new['cmp_fax'] = $this->input->post("cmp_fax");
                $data_new['cmp_province'] = $this->input->post("cmp_province");
//                $data_new['cmp_city'] = $this->input->post("cmp_city");
                $data_new['cmp_status'] = $this->input->post("cmp_status");
                $data_new['cmp_melli_code'] = $this->input->post("cmp_melli_code");
                $data_new['cmp_economy_code'] = $this->input->post("cmp_economy_code");
                $data_new['cmp_username'] = $this->input->post("cmp_username");
                $data_new['cmp_password'] = $this->input->post("cmp_password");

                $config['upload_path'] = './images/company/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('image'))
                {
                    $img = $this->upload->data();
                    $data_new['cmp_image'] = $img["file_name"];
                }

                if($this->company_model->update($where, $data_new))
                {

                    if($sms){
                        $this->sendSmd($this->input->post("cmp_mobile") , "---");
                    }

                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ویرایش شد";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travel_company'));
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travel_company', 'edit_admin', $data['content'][0]->cmp_id)));

                }

            }//end of check form_validation
        }//end of check post edit btn


        $data['province'] = $this->city_model->get_province('*');
        $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
        $this->load->view("edit_company_admin", $data);



    }//edit



    function sendSmd($mobile , $code  ){
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverConfirmAccount");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
        return TRUE ;
    }//send_sms




    function delete() {

        $this->config_model->check_login("ADMIN");
        $where['cmp_id'] = $this->uri->segment(3);

        if(!is_numeric($where['cmp_id']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "شماره یافت نشد ";
            $this->session->set_flashdata($msg);
            redirect(site_url('travel_company'));
        }
        $data['content'] = $this->company_model->get('*', $where);

        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "اطلاعات یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('travel_company'));
        }
                $data_new['cmp_phone'] = NULL;
                $data_new['cmp_mobile'] = NULL;
                $data_new['cmp_fax'] = NULL;
                $data_new['cmp_melli_code'] = NULL;
                $data_new['cmp_economy_code'] = NULL;
                $data_new['cmp_username'] = NULL;
                $data_new['cmp_password'] =NULL;
                $data_new['cmp_code'] =NULL;
                $data_new['cmp_status'] ="3";
                if($this->company_model->update($where, $data_new))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت حذف شد";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travel_company'));
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travel_company'));

                }
    }//delete


}//end of class
