<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Colleague extends CI_Controller {
    function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->load->model('config/config_model');
    $this->load->model('travelcompany/colleague_model');
      $this->load->model('travelcompany/company_model');
    $this->load->model('setting_model');
  }
    function index() {
      if(!$this->config_model->check_login("COMPANY")){
          redirect(site_url('travelcompany/log_in'));
      }
      $company_id = $this->session->userdata("cmp_id") ;
      $like = NULL ;
      $this->load->library('pagination');
      $where['co_cmp_id'] = $company_id ;
      $where['co_status !='] = "3" ;
      $config['base_url'] = site_url(array('travelcompany/colleague','index'));
      $config['total_rows'] = sizeof($this->colleague_model->get('co_id' , $where ));
      $config['per_page'] = 20;
      $config['uri_segment'] = 4;
      $config['first_link'] = '&#1575;&#1608;&#1604;&#1740;&#1606;';
      $config['last_link'] = '&#1570;&#1582;&#1585;&#1740;&#1606;';
      $config['next_link'] = '&#1576;&#1593;&#1583;&#1740;';
      $config['prev_link'] = '&#1602;&#1576;&#1604;&#1740;';
      $config['full_tag_open'] = '<ul class="pagination">';
      $config['full_tag_close'] = '</ul>';
      $config['first_tag_open'] = '<li>';
      $config['first_tag_close'] = '</li>';
      $config['last_tag_open'] = '<li>';
      $config['last_tag_close'] = '</li>';
      $config['num_tag_open'] = '<li>';
      $config['num_tag_close'] = '</li>';
      $config['cur_tag_open'] = '<li class="active"><a href="">';
      $config['cur_tag_close'] = '</a></li>';
      $config['next_tag_open'] = '<li class="next">';
      $config['next_tag_close'] = '</li>';
      $config['prev_tag_open'] = '<li class="prev">';
      $config['prev_tag_close'] = '</li>';

      $this->pagination->initialize($config);
      $data['pagination'] = $this->pagination->create_links();

      $where_get['co_cmp_id'] =  $this->session->userdata("cmp_id");
    $data['content'] = $this->colleague_model->get("*",$where_get);
    foreach ($data['content'] as $item){
        if($item->co_status == "0"){
            $item->co_status = "غیر فعال";
        }
        else if($item->co_status == "1"){
            $item->co_status = " فعال";
        }
        else if($item->co_status == "2"){
            $item->co_status = "مسدود";
        }

        $item->d_company = $this->company_model->get_name_by_id($item->co_cmp_id);
    }




    $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
    $this->load->view('travelcompany/colleague_list', $data);
  }//end of index function
    function add() {
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        if($this->input->post("register_btn"))
        {
            $this->load->library('form_validation');

            $this->form_validation->set_rules('co_name','نام همکار','required');
            $this->form_validation->set_rules('co_family','نام خانوادگی','required');
            $this->form_validation->set_rules('co_mobile','موبایل','required|numeric|is_unique[_colleague.co_mobile]');

            $this->form_validation->set_message('required', 'وارد کردن فيلد %s الزامي است');
            $this->form_validation->set_message('is_unique', 'اين %s قبلا ثبت شده است');
            $this->form_validation->set_message('numeric', '%s بايد عدد باشد');

            if($this->form_validation->run() != FALSE)
            {
                $data['co_name'] = $this->input->post("co_name");
                $data['co_family'] = $this->input->post("co_family");
                $data['co_mobile'] = $this->input->post("co_mobile");
                $data['co_cmp_id']  = $this->session->userdata("cmp_id") ;

                if($this->colleague_model->insert($data))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travelcompany/colleague')); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travelcompany/colleague', 'add')));
                }

            }//end of check form_validation
        }//end of check post register btn


        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view("travelcompany/add_colleague", $data);
    }//add
    function edit() {
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        $where['co_id'] = $this->uri->segment(4);
        $data['content'] = $this->colleague_model->get("*", $where);
        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "یافت نشد !";
            $this->session->set_flashdata($msg);
            redirect(site_url('travelcompany/colleague')); // TODO
        }



        if($this->input->post("btn_edit"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('co_name','نام همکار','required');
            $this->form_validation->set_rules('co_family','نام خانوادگی','required');
            $this->form_validation->set_rules('co_mobile','موبایل','required|numeric|is_unique[_colleague.co_mobile]');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {
                $data_update['co_name'] = $this->input->post("co_name");
                $data_update['co_family'] = $this->input->post("co_family");
                $data_update['co_mobile'] = $this->input->post("co_mobile");

                if($this->colleague_model->update($where , $data_update))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('travelcompany/colleague')); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travelcompany/colleague', 'edit')));
                }

            }//end of check form_validation
        }//end of check post register btn


        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view("travelcompany/edit_colleague", $data);

    }//edit
    function delete() {
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        $where['co_id'] = $this->uri->segment(4);
        if(!is_numeric($where['co_id']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "شمارنده یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('travelcompany/colleague')); // TODO
        }

        $data['content'] = $this->colleague_model->get("*", $where);
        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "مشخصات یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('travelcompany/colleague')); // TODO
        }

        $data_update['co_status'] = "3";
        $data_update['co_mobile'] = NULL;
        if($this->colleague_model->update($where , $data_update)){
            $msg['msg'][0] = 'success';
            $msg['msg'][1] = "با موفقیت پاک شد.";
            $this->session->set_flashdata($msg);
            redirect(site_url('travelcompany/colleague')); // TODO
        }
        else
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "خطا در ثبت اطلاعات";
            $this->session->set_flashdata($msg);
            redirect(site_url('travelcompany/colleague')); // TODO
        }
    }//delete
    function search(){
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        $company_id = $this->session->userdata("cmp_id") ;
        $like = NULL ;
        $this->load->library('pagination');

        $like['co_name'] =  $this->input->get('search');
        $like['co_family'] = $this->input->get('search');
        $like['co_mobile'] = $this->input->get('search');

        $where['co_cmp_id'] = $company_id ;
        $where['co_status !='] = "3" ;

        $data['pagination'] = NULL;
        $data['content'] = $this->colleague_model->search("*",$where , "co_id desc" , "co_id" , $like);
//      var_dump($data['content']);
//      exit();

        foreach ($data['content'] as $item){

            if($item->co_status == "0"){
                $item->co_status = "غیر فعال";
            }
            else if($item->co_status == "1"){
                $item->co_status = " فعال";
            }
            else if($item->co_status == "2"){
                $item->co_status = "مسدود";
            }

            $item->d_company = $this->company_model->get_name_by_id($item->co_cmp_id);
        }
        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view('travelcompany/colleague_list', $data);
    }//search
    function send_sms_company_register($mobile = '09120917577', $code = '159263') {
        $api_key["apikey"] = "78504F5167616A463741762B656253304A6978535474684E685A715439306E4C";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "verify");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
    }// end of sendSms
}//end of class
