<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Register extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->model('main/admin_model');//TODO
        $this->load->model('config/config_model');
        $this->load->model('travelcompany/company_model');
        $this->load->library('session');
        $this->load->database();
    }
    function index()
    {
        $this->load->view("travelcompany/nregister", NULL);
    }//end of index function
    function edit()
    {
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        $company_id = $this->session->userdata("cmp_id") ;
        $where['cmp_id'] = $company_id;
        $data['content'] = $this->company_model->get("*",$where);
        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view("travelcompany/edit_cmp", $data);
    }//end of index function
    function verifyMobile()
    {
        $this->load->model('travelcompany/company_model');
        if($this->input->post("register_btn"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('verify_code','کد تائیدیه','required');
            $this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است' );

            if($this->form_validation->run() != FALSE)
            {
                $mobile =  $this->uri->segment(4);
                if($this->company_model->verify_mobile($this->input->post("verify_code") , $mobile))
                {

                    $where_company['cmp_mobile'] = $mobile;
                    $data_cmp = $this->company_model->get('cmp_id , cmp_image , cmp_status,cmp_name , cmp_lat',$where_company);
                    $company_data = array(
                        'company_pannel' => "1",
                        'cmp_id' => $data_cmp[0]->cmp_id,
                        'cmp_image' => $data_cmp[0]->cmp_image,
                        'cmp_status' => $data_cmp[0]->cmp_status,
                        'cmp_name' => $data_cmp[0]->cmp_name);
                    $this->session->set_userdata($company_data);


                    if($data_cmp[0]->cmp_lat == NULL){
                        redirect(site_url('travelcompany/company_position')); // TODO
                    }else{
                        redirect(site_url('travelcompany/log_in')); // TODO
                    }



                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "کد اشتباه است";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('travelcompany/register/verifyMobile/'.$mobile)));
                }

            }//end of check form_validation
        }//end of check post register btn
        $this->load->view("travelcompany/verifymobile", NULL);//TODO
    }//end of index function
    function send_sms_company_register($mobile = '09120917577', $code = '159263') {
        $api_key["apikey"] = "78504F5167616A463741762B656253304A6978535474684E685A715439306E4C";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "verify");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
    }// end of sendSms
    function date_convert($miladi_date)
    {
        error_reporting(0);
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function
    function upload_image($path , $unlink , $image){
        $config['upload_path'] = $path;
        $config['allowed_types'] = 'gif|jpg|png|jpeg';
        $config['encrypt_name'] = 'true';
        $this->load->library('upload',$config);
        if($this->upload->do_upload('image'))
        {
            $img = $this->upload->data();
            if($unlink){
                if(file_exists($path.$image))
                    unlink($path.$image);
            }
            return $img["file_name"];
        }else{
            return false ;
        }
    }// end of upload_image
    function get_cities()
    {
        $this->load->model('travelcompany/city_model');
        $where['province_id'] = $this->input->post('id');
        $res = $this->city_model->get('id , name ', $where);
        if (!empty($res)) {
            foreach ($res as $item)
            {
                $row = array();
                $row["id"] = $item->id;
                $row["name"] = $item->name;
                $jsonData["cities"][] = $row;
            }
        } else {
            $jsonData["status"] = "error";
        }
        echo json_encode($jsonData);
    }//get_cities
    function get_all_cities()
    {
        $this->load->model('travelcompany/city_model');
        $res = $this->city_model->get('id , name ');
        if (!empty($res)) {
            foreach ($res as $item)
            {
                $row = array();
                $row["id"] = $item->id;
                $row["name"] = $item->name;
                $jsonData["cities"][] = $row;
            }
        } else {
            $jsonData["status"] = "error";
        }
        echo json_encode($jsonData);
    }//get_cities
}//end of class