<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
date_default_timezone_set('Asia/Tehran');


class Webservice_js extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->library('session');
        $this->load->database();
    }
    function index()
    {

    }//end of index function
    function company_dashboard()
    {
        $this->load->model('barname_model');
        $this->load->model('rate_model');
        $this->load->model('main/requests_model');
        $this->load->model('travelcompany/drivers_model');

        $cmp_id = $this->input->post('cmp_id');

        $drivers_count = $this->drivers_model->cmp_drivers_count($cmp_id);

        $bar_count = $this->requests_model->cmp_bar_count($cmp_id);
        $bar_count_finished = $this->requests_model->cmp_bar_count_finished($cmp_id);
        $bar_count_indo = $this->requests_model->cmp_bar_count_indo($cmp_id);

        $barname_count = $this->barname_model->cmp_barname_count($cmp_id);
        $barname_count_pay = $this->barname_model->cmp_barname_count_pay($cmp_id);
        $barname_count_pay_price_total = $this->barname_model->cmp_barname_count_pay_price($cmp_id);

        $company_rate = $this->rate_model->cmp_rate($cmp_id);

        $jsonData['drivers_count'] = $drivers_count;
        $jsonData['bar_count'] = $bar_count;
        $jsonData['bar_count_finished'] = $bar_count_finished;
        $jsonData['bar_count_todo'] = $bar_count_indo;
        $jsonData['barname_count'] = $barname_count;
        $jsonData['barname_count_pay'] = $barname_count_pay;
        $jsonData['barname_count_price'] = $barname_count_pay_price_total;
        $jsonData['rate'] = round($company_rate, 2);

        echo json_encode($jsonData);

    }//end of index function
    function admin_dashboard()
    {
        $this->load->model('barname_model');
        $this->load->model('rate_model');
        $this->load->model('main/requests_model');
        $this->load->model('travelcompany/drivers_model');


        $drivers_count = $this->drivers_model->drivers_count();

        $bar_count = $this->requests_model->bar_count();
        $bar_count_finished = $this->requests_model->bar_count_finished();
        $bar_count_indo = $this->requests_model->bar_count_indo();

        $barname_count = $this->barname_model->barname_count();
        $barname_count_pay = $this->barname_model->barname_count_pay();
        $barname_count_pay_price_total = $this->barname_model->barname_count_pay_price();


        $jsonData['drivers_count'] = $drivers_count;
        $jsonData['bar_count'] = $bar_count;
        $jsonData['bar_count_finished'] = $bar_count_finished;
        $jsonData['bar_count_todo'] = $bar_count_indo;
        $jsonData['barname_count'] = $barname_count;
        $jsonData['barname_count_pay'] = $barname_count_pay;
        $jsonData['barname_count_price'] = $barname_count_pay_price_total;
        $jsonData['rate'] = "";

        echo json_encode($jsonData);

    }//end of index function
    function requests_detail()
    {
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $this->load->model('barname_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/colleague_model');
        $this->load->model('driver_suggestion_model');

        $where['req_id'] = $this->input->post('req_id');
        $req_data = $this->requests_model->get('*', $where);

        $jsonData['req_company'] = $this->company_model->get_name_by_id($req_data[0]->req_company);
        $jsonData['req_lat1'] = $req_data[0]->req_lat1;
        $jsonData['req_lng1'] = $req_data[0]->req_lng1;
        $jsonData['req_lat2'] = $req_data[0]->req_lat2;
        $jsonData['req_lng2'] = $req_data[0]->req_lng2;
        $jsonData['req_address1'] = $req_data[0]->req_address1;
        $jsonData['req_address2'] = $req_data[0]->req_address2;
        $jsonData['req_dess'] = $req_data[0]->req_dess;
        $jsonData['req_dess'] = $this->setting_model->get_setting_name($req_data[0]->req_dess);
        $jsonData['req_bar_kind'] = $this->setting_model->get_setting_name($req_data[0]->req_bar_kind);
        $jsonData['req_bar_packet'] = $this->setting_model->get_setting_name($req_data[0]->req_bar_packet);
        $jsonData['req_bar_vazn'] = $this->setting_model->get_setting_name($req_data[0]->req_bar_vazn);
        $jsonData['req_bar_device'] = $this->setting_model->get_setting_name($req_data[0]->req_bar_device);
        $jsonData['req_takhlie'] = $this->setting_model->get_setting_name($req_data[0]->req_takhlie);
        $jsonData['req_distance'] = $this->setting_model->get_setting_name($req_data[0]->req_distance);
        $jsonData['req_peyment_kind'] = $this->setting_model->get_setting_name($req_data[0]->req_peyment_kind);
        $jsonData['req_colleague'] = $this->colleague_model->get_colleague_name($req_data[0]->req_colleague);
        $jsonData['req_bar_admin'] = $req_data[0]->req_bar_admin;
        $jsonData['req_send_all'] = "بله";

        if ($req_data[0]->req_send_all == "0") {
            $jsonData['req_send_all'] = "خیر";
        };

        $jsonData['req_olaviat'] = $req_data[0]->req_olaviat;
        $jsonData['req_bar_price'] = $req_data[0]->req_bar_price;
        $jsonData['req_barname_price'] = $req_data[0]->req_barname_price;
        $jsonData['req_olaviat'] = $req_data[0]->req_olaviat;
        $jsonData['req_code'] = $req_data[0]->req_code;
        $jsonData['req_city1'] = $req_data[0]->req_city1;
        $jsonData['req_city2'] = $req_data[0]->req_city2;

        $data_active_barname = $this->barname_model->check_barname_requests($this->input->post('req_id'));
        if ($data_active_barname != "0") {
            $jsonData['bf_bar_price'] = $this->driver_suggestion_model->get_bar_price($this->input->post('req_id'), $data_active_barname[0]->bf_driverid);
            $jsonData['bf_remain'] = (int)((900 - $this->barname_model->get_barnameh_dead_time($this->input->post('req_id'))) / 60) . " دقیقه ";
            $jsonData['bf_id'] = $data_active_barname[0]->bf_id;
            $jsonData['bf_price'] = $data_active_barname[0]->bf_price;
            $jsonData['bf_driverid'] = $data_active_barname[0]->bf_driverid;
            $jsonData['bf_date'] = $this->date_convert($data_active_barname[0]->bf_date);

            $barname_status = $data_active_barname[0]->bf_status;
            if ($barname_status == "1") {
                $jsonData['bf_status'] = "در انتظار پرداخت توسط راننده";
            } else if ($barname_status == "2") {
                $jsonData['bf_status'] = "پرداخت شده";
            }


            $jsonData['bf_cancell_time'] = $data_active_barname[0]->bf_cancell_time;
            $jsonData['bf_code'] = $data_active_barname[0]->bf_code;
            $jsonData['bf_peyment_date'] = $data_active_barname[0]->bf_peyment_date;
        } else {
            $jsonData['bf_bar_price'] = "";
            $jsonData['bf_remain'] = "";
            $jsonData['bf_id'] = "";
            $jsonData['bf_price'] = "";
            $jsonData['bf_driverid'] = "";
            $jsonData['bf_date'] = "";
            $jsonData['bf_status'] = "بارنامه ی در انتظار پرداخت ندارید";
            $jsonData['bf_cancell_time'] = "";
            $jsonData['bf_code'] = "";
            $jsonData['bf_peyment_date'] = "";
        }

        $jsonData['d_name'] = "راننده ای انتخاب نشده است";
        $jsonData['d_mobile'] = "";
        $jsonData['d_owner'] = "";
        $jsonData['d_image'] = "";
        $jsonData['d_device'] = "";
        $jsonData['d_pelak'] = "";
        $jsonData['d_card_nm'] = "";
        $jsonData['d_card_nm_device'] = "";

        if ($req_data[0]->req_driverid != "0") {
            $where_driver['d_id'] = $req_data[0]->req_driverid;
            $data_driver = $this->drivers_model->get("*",$where_driver);
            $jsonData['d_name'] = $data_driver[0]->d_name . " " . $data_driver[0]->d_family;
            $jsonData['d_mobile'] = $data_driver[0]->d_mobile;
            $jsonData['d_owner'] = $data_driver[0]->d_mobile_owner;
            $jsonData['d_image'] = $data_driver[0]->d_image;
            $jsonData['d_device'] =  $this->setting_model->get_setting_name($data_driver[0]->d_device);
            $jsonData['d_pelak'] = $data_driver[0]->d_pelak;
            $jsonData['d_card_nm'] = $data_driver[0]->d_num_card_driver;
            $jsonData['d_card_nm_device'] = $data_driver[0]->d_num_card_device;
        }

        $jsonData['req_driverid'] = $req_data[0]->req_driverid;

        switch ($req_data[0]->req_status) {
            case "0":
                $jsonData['req_status_dess'] = "این درخواست لغو شده است";
                break;
            case "1":
                $jsonData['req_status_dess'] = "در مرحله ی ارسال پیشنهاد ";
                break;
            case "2":
                $jsonData['req_status_dess'] = "راننده بارنامه را پرداخت کرده است";
                break;
            case "3":
                $jsonData['req_status_dess'] = "راننده دریافت بارنامه را تایید کرده و در حال حرکت به محل بارگیری است";
                break;
            case "4":
                $jsonData['req_status_dess'] = "راننده به محل بارگیری رسید";
                break;
            case "5":
                $jsonData['req_status_dess'] = "راننده در حال حرکت به سمت مقصد است";
                break;
            case "6":
                $jsonData['req_status_dess'] = "این درخواست انجام شده است";
                break;
        }

        $jsonData['req_status'] = $req_data[0]->req_status;
        $jsonData['req_date'] = $this->date_convert($req_data[0]->req_date);
        echo json_encode($jsonData);

    }//end of index function
    function register_company()
    {
        $this->load->model('travelcompany/company_model');
        $this->load->library('form_validation');

        $data['cmp_name'] = $this->input->post("reg_company_name");
        $data['cmp_type'] = $this->input->post("reg_company_type");
        $data['cmp_kind'] = $this->input->post("reg_company_kind");
        $data['cmp_management'] = $this->input->post("reg_company_management");
        $data['cmp_phone'] = $this->input->post("reg_company_phone");
        $data['cmp_mobile'] = $this->input->post("reg_company_mobile");
        $data['cmp_fax'] = $this->input->post("reg_company_fax");
        $data['cmp_province'] = $this->input->post("province_id");
        $data['cmp_city'] = $this->input->post("city_id");
        $data['cmp_code'] = $this->input->post("reg_company_code");
        $data['cmp_melli_code'] = $this->input->post("reg_company_melli_code");
        $data['cmp_economy_code'] = $this->input->post("reg_company_economy_code");
        $data['cmp_username'] = $this->input->post("reg_username");
        $data['cmp_password'] = $this->input->post("reg_password");
        $data['cmp_email'] = $this->input->post("reg_email");
        $data['cmp_verify_code'] = rand(1001, 9999);

        if (!$this->company_model->is_unique($this->input->post("reg_email"), "cmp_email")) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "ایمیل تکراری است";
            echo json_encode($jsonData);
        } else if (!$this->company_model->is_unique($this->input->post("reg_company_mobile"), "cmp_mobile")) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره موبایل تکراری است";
            echo json_encode($jsonData);
        } else if (!$this->company_model->is_unique($this->input->post("reg_company_phone"), "cmp_phone")) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره تلفن تکراری است";
            echo json_encode($jsonData);
        } else if (!$this->company_model->is_unique($this->input->post("reg_company_code"), "cmp_code")) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره کد شرکت تکراری است";
            echo json_encode($jsonData);
        } else if (!$this->company_model->is_unique($this->input->post("reg_username"), "cmp_username")) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره کاربری تکراری است";
            echo json_encode($jsonData);
        } else if ($this->company_model->insert($data)) {
            $jsonData['status'] = "ok";
            $this->send_sms_company_register($data['cmp_mobile'], $data['cmp_verify_code']);
            echo json_encode($jsonData);
        } else {
            $jsonData['status'] = "error";
            $jsonData['message'] = "لطفا دوباره تلاش کنید";
            echo json_encode($jsonData);
        }

    }//register company
    function send_sms_againe()
    {
        $this->load->model('travelcompany/company_model');
        $where['cmp_mobile'] = $this->input->post("mobile");
        $code = $this->company_model->get_code_sms($this->input->post("mobile"));
        if ($code == "1") {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره موبایل یافت نشد";
        } else if ($code == "0") {
            $jsonData['status'] = "error";
            $jsonData['message'] = "کد صفر را در قسمت کد تاییدیه وارد کنید";
        } else {
            $jsonData['status'] = "ok";
            $this->send_sms_company_register($this->input->post("mobile"), $code);
        }
        echo json_encode($jsonData);
    }
    function forget_pass()
    {
        $this->load->model('travelcompany/company_model');
        $where['cmp_mobile'] = $this->input->post("mobile");
        $data = $this->company_model->get("cmp_password", $where);
        if (empty($data)) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره موبایل یافت نشد";
        } else {
            $jsonData['status'] = "ok";
            $this->send_sms_company_register($this->input->post("mobile"), $data[0]->cmp_password);
        }
        echo json_encode($jsonData);
    }//forget_pass
    function submit_company_position()
    {
        $this->load->model('travelcompany/company_model');
        $where['cmp_id'] = $this->input->post("cmp_id");
        $where['cmp_lat'] = NULL;
        $data['cmp_lat'] = $this->input->post("lat");
        $data['cmp_lng'] = $this->input->post("lng");
        $data['cmp_address'] = $this->input->post("address");

        $data_check = $this->company_model->get("cmp_id", $where);
        if (!empty($data_check)) {
            if ($this->company_model->update($where, $data)) {
                $jsonData['status'] = "ok";
            } else {
                $jsonData['status'] = "error";
                $jsonData['message'] = "دوباره امتحان کنید";
            }
        } else {
            $jsonData['status'] = "error";
            $jsonData['message'] = "شما فقط یک بار مجاز به تعیین آدرس هستید";
        }
        echo json_encode($jsonData);
    }//submit_company_position
    function change_mobile_number()
    {
        $this->load->model('travelcompany/company_model');
        $where['cmp_mobile'] = $this->input->post("mobile");
        $code = $this->company_model->get_code_sms($this->input->post("mobile"));
        $data['cmp_mobile'] = $this->input->post("mobile_new");
        if ($this->company_model->update($where, $data)) {
            $jsonData['status'] = "ok";
            $this->send_sms_company_register($this->input->post("mobile_new"), $code);
        } else {
            $jsonData['status'] = "error";
            $jsonData['message'] = "دوباره امتحان کنید";
        }
        echo json_encode($jsonData);
    }
    function submit_bar()
    {
        $this->load->model('main/requests_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('setting_model');



        $where_cmpany['cmp_id'] = $this->session->userdata("cmp_id");
        $data_company = $this->company_model->get("cmp_lat,cmp_lng",$where_cmpany);
        $cmp_lat = $data_company[0]->cmp_lat;
        $cmp_lng =$data_company[0]->cmp_lng;

        $data_add['req_lat1'] = $cmp_lat;
        $data_add['req_lng1'] =$cmp_lng;


        $data_add['req_lat2'] = $this->input->post("second_lat");//ok
        $data_add['req_lng2'] = $this->input->post("second_lng");//ok


        $data_add['req_company'] = $this->session->userdata("cmp_id");
        $data_add['req_address1'] = $this->input->post("req_address1");//ok
        $data_add['req_address2'] = $this->input->post("req_address2");//ok

        $data_add['req_bar_kind'] = $this->input->post("req_bar_kind");//ok
        $data_add['req_bar_packet'] = $this->input->post("req_bar_packet");//ok
        $data_add['req_bar_vazn'] = $this->input->post("req_bar_vazn");//ok

        $data_add['req_bar_price'] = $this->input->post("req_bar_price1") . $this->input->post("req_bar_price2") . "000";//ok
        $data_add['req_barname_price'] = $this->input->post("req_barname_price1") . $this->input->post("req_barname_price2") . "000";//ok
        $data_add['req_olaviat'] = $this->input->post("req_olaviat");//ok
        $data_add['req_peyment_kind'] = $this->input->post("req_peyment_kind");//ok
        $data_add['req_distance'] = $this->input->post("req_distance");//ok
        $data_add['req_takhlie'] = $this->input->post("req_takhlie");//ok
        $data_add['req_bar_admin'] = $this->input->post("req_bar_admin");//ok
        $data_add['req_send_all'] = $this->input->post("req_send_all");//ok
        $data_add['req_colleague'] = $this->input->post("req_colleague");//ok
        $data_add['req_city1'] = $this->input->post("req_city1");//ok
        $data_add['req_city2'] = $this->input->post("req_city2");//ok


        $data_add['req_dess'] = $this->input->post("req_dess");//ok
        $data_add['req_bar_device'] = $this->input->post("req_bar_device");//ok




        if ($req_id_db = $this->requests_model->insert($data_add)) {
            $jsonData['status'] = "ok";
            echo json_encode($jsonData);
            $where_code['req_id'] = $req_id_db;
            $data_code['req_code'] = "T-" . $req_id_db;
            $this->requests_model->update($where_code, $data_code);
            $this->send_sms_to_colleague($this->input->post("req_colleague") , "T-" . $req_id_db);


            $req_distance = $this->setting_model->get_setting_name($this->input->post("req_distance"));

            $this->driver_alarm($req_distance, $data_add['req_bar_device'], $req_id_db,$this->input->post("req_send_all"),$cmp_lat,$cmp_lng);
        } else {
            $jsonData['status'] = "error";
            $jsonData['message'] = "لطفا دوباره تلاش کنید";
            echo json_encode($jsonData);
        }

    }//register company


    function send_sms_to_colleague($id , $code){

        //Colleague_model
        $this->load->model('travelcompany/colleague_model');


        $where['co_id'] = $id;
        $data = $this->colleague_model->get("co_mobile",$where);
        if(!empty($data)){

            $mobile = $data[0]->co_mobile ;
            $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
            $this->load->library('sms/api', $api_key);
            try {
                $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverColleague");
//         echo var_dump($result);
            } catch (ApiException $ex) {
                echo $ex->errorMessage();
            } catch (HttpException $ex) {
                echo $ex->errorMessage();
            }
            return TRUE ;
        }

    }//send_sms_to_colleague






    function driver_alarm($distance = "278", $device="30", $req_id="171" , $all="0" , $lat="35.7005924" , $lng="51.4026453")
    {

        $this->load->model('log_model');
        $data_log['_id']= "0" ;
        $data_log['value1']= $distance ;
        $data_log['value2']= $device ;
        $data_log['value3']= $req_id ;
        $data_log['value4']= $all ;
        $data_log['value5']= $lat ;
        $data_log['value6']= $lng ;
        $this->log_model->insert($data_log);

        $devices_arr = explode(',',$device);

        for($i=0 ; $i < sizeof($devices_arr) ; $i++ ){
            //        $distance = "2000000";
            $distance *= 1000 ;
            $this->load->model('travelcompany/drivers_model');
            $data = $this->drivers_model->get_drivers_active($distance, $devices_arr[$i] , $all,$lat , $lng);
            foreach ($data as $item) {
                $firebase_code = $item->d_firebase_code;
                $distance_driver = $item->distance;
                $title = "اعلام بار جدید در محدوده شما";
                $dess = "برای دیدن جزییات کلیک کنید";
                $this->send_to_drivers("1", $title, $dess, $firebase_code, $req_id , $distance_driver);
            }


        }





    }//driver_alarm

    function send_to_drivers($kind, $title, $message, $firebase_code, $req_id , $distance_driver="0")
    {

        $url = 'https://fcm.googleapis.com/fcm/send';
        $fields = array(
            'to' => $firebase_code,
            'priority' => 'high',
            'time_to_live' => 40,
            'data' => array(
                "title" => $title, //title
                "message" => $message, // message
                "kind" => $kind, // kind
                "req_id" => $req_id   // req_id
            )
        );
        $fields = json_encode($fields);
        $headers = array(
            'Authorization: key=' . "AAAA2qTcEDs:APA91bEOOQ0Y3UJQKjfYMOPH4inumJhQRIZBRJtzQiaaPARloJkeRzIIxFyMvjV0BNlOgauTsXCl9Ks2NwK224JdLDshaAlPNlAQJ415mPLqpURN-0_qhWtCxaGksEUXel_cor6kPMyq2QoFE1J005sljSOnWVePFw",
            'Content-Type: application/json'
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        $result = curl_exec($ch);
        curl_close($ch);
//        echo"<br>";
//        var_dump($result);

        $this->load->model('log_model');
        $data['_id']= $firebase_code ;
        $data['value1']= $req_id ;
        $data['value2']= $distance_driver ;
        $data['value3']= $result ;
        $data['value4']= $result ;
        $data['value5']= $result ;
        $data['value6']= $result ;
        $this->log_model->insert($data);


    }// end of send_to_drivers
    function acc_sug_cha_bar()
    {
        $this->load->model('driver_suggestion_model');
        $this->load->model('barname_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('main/requests_model');

        $price_acc_sug_cha_barsuggest = $this->input->post('price_acc_sug_cha_barsuggest');

        $req_id = $this->driver_suggestion_model->get_req_id($this->input->post('ds'));
        $driverid = $this->driver_suggestion_model->get_driverid($this->input->post('ds'));

        $barname_time = $this->barname_model->get_barnameh_dead_time($req_id);
        $accept_barname = false;
        if ($barname_time == "0") {
            $accept_barname = true;
        } else if ($barname_time > 900) {
            $accept_barname = true;
            $this->barname_model->cancell_barname_by_system($req_id, $driverid);
        }

        $trip_status = $this->requests_model->get_req_status($req_id);
        if ($trip_status == "1") {

            if ($accept_barname) {
                if ($this->driver_suggestion_model->accept_suggestion($req_id, $driverid)) {
                    $where_price['req_id'] = $req_id;
                    $data_price['req_barname_price'] = $this->input->post('price');
                    $data_price['req_bar_price_driver'] = $price_acc_sug_cha_barsuggest;
                    if ($this->requests_model->update($where_price, $data_price)) {
                        $this->driver_suggestion_model->accept_suggestion($req_id, $driverid);
                        $data_barname_factor['bf_price'] = $this->requests_model->get_barname_price($req_id);
                        $data_barname_factor['bf_reqid'] = $req_id;
                        $data_barname_factor['bf_driverid'] = $driverid;
                        $data_barname_factor['bf_status'] = "1";
                        $data_barname_factor['bf_time_peyment'] = "30";
                        $data_barname_factor['bf_price_bar']  = $this->input->post('price_suggest');

                        $where['d_id'] = $driverid;
                        if ($bf_id = $this->barname_model->insert($data_barname_factor)) {
                            $where_b_price['req_id'] = $req_id;
                            $data_b_price['req_barname_id'] = $bf_id;
                            $this->requests_model->update($where_b_price, $data_b_price);


                            $jsonData['status'] = "ok";
                            $data_firebase_code = $this->drivers_model->get("d_firebase_code", $where);
                            foreach ($data_firebase_code as $item) {
                                $firebase_code = $item->d_firebase_code;
                                $title = "پیشنهاد شما قبول شد ";
                                $dess = "برای پرداخت بارنامه کلیک کنید";
                                $this->send_to_drivers("2", $title, $dess, $firebase_code, $req_id);

                            }
                        } else {
                            $jsonData['status'] = "error";
                        }
                    } else {
                        $jsonData['status'] = "error";
                        $jsonData['message'] = "لطفا دوباره تلاش کنید";
                    }
                } else {
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "دوباره امتحان کنید";
                }
            } else {
                $jsonData['status'] = "error";
                $jsonData['message'] = "بارنامه در حال پرداخت دارید و این پیشنهاد تا تعیین وضعیت بارنامه ی در حال پرداخت قبول نمیشود";
            }

        } else {
            $jsonData['status'] = "error";
            switch ($trip_status) {
                case "0":
                    $jsonData['message'] = "این درخواست لغو شده است.";
                    break;
                case "6":
                    $jsonData['message'] = "این درخواست انجام شده است.";
                    break;
                default:
                    $jsonData['message'] = "این درخواست در حال انجام است.";
                    break;
            }
        }
        echo json_encode($jsonData);
    }//accept_suggestion


    function accept_suggestion()
    {
        $this->load->model('driver_suggestion_model');
        $this->load->model('barname_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('main/requests_model');

        $price_acc_sug_cha_barsuggest = $this->input->post('price_acc_sug_cha_barsuggest');
        $req_id = $this->driver_suggestion_model->get_req_id($this->input->post('ds'));
        $driverid = $this->driver_suggestion_model->get_driverid($this->input->post('ds'));

        $barname_time = $this->barname_model->get_barnameh_dead_time($req_id);
        $accept_barname = false;
        if ($barname_time == "0") {
            $accept_barname = true;
        } else if ($barname_time > 900) {
            $accept_barname = true;
            $this->barname_model->cancell_barname_by_system($req_id, $driverid);
        }

        $trip_status = $this->requests_model->get_req_status($req_id);
        if ($trip_status == "1") {


            if ($accept_barname) {

                if ($this->driver_suggestion_model->accept_suggestion($req_id, $driverid)) {
                    $data_barname_factor['bf_price'] = $this->requests_model->get_barname_price($req_id);
                    $data_barname_factor['bf_reqid'] = $req_id;
                    $data_barname_factor['bf_driverid'] = $driverid;
                    $data_barname_factor['bf_status'] = "1";
                    $data_barname_factor['bf_time_peyment'] = "30";
                    $data_barname_factor['bf_price_bar']  = $this->input->post('price_suggest');

                    $where['d_id'] = $driverid;
                    if ($bf_id = $this->barname_model->insert($data_barname_factor)) {
                        $where_b_price['req_id'] = $req_id;
                        $data_b_price['req_barname_id'] = $bf_id;
                        $data_b_price['req_bar_price_driver'] = $price_acc_sug_cha_barsuggest;
                        $this->requests_model->update($where_b_price, $data_b_price);
                        $jsonData['status'] = "ok";
                        $data_firebase_code = $this->drivers_model->get("d_firebase_code", $where);
                        foreach ($data_firebase_code as $item) {
                            $firebase_code = $item->d_firebase_code;
                            $title = "پیشنهاد شما قبول شد";
                            $dess = "برای پرداخت بارنامه کلیک کنید";
                            $this->send_to_drivers("2", $title, $dess, $firebase_code, $req_id);

                        }
                    } else {
                        $jsonData['status'] = "error";
                    }
                } else {
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "دوباره امتحان کنید";
                }
            } else {
                $jsonData['status'] = "error";
                $jsonData['message'] = "بارنامه در حال پرداخت دارید و این پیشنهاد تا تعیین وضعیت بارنامه ی در حال پرداخت قبول نمیشود";
            }
        } else {
            $jsonData['status'] = "error";
            switch ($trip_status) {
                case "0":
                    $jsonData['message'] = "این درخواست لغو شده است.";
                    break;
                case "6":
                    $jsonData['message'] = "این درخواست انجام شده است.";
                    break;
                default:
                    $jsonData['message'] = "این درخواست در حال انجام است.";
                    break;
            }
        }

        echo json_encode($jsonData);
    }//accept_suggestion
    function admin_barname_filter(){
        $this->load->model('barname_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');


        $req_company  = $this->input->post('req_company');
        $bf_status  = $this->input->post('req_status');
        $start   = $this->input->post('start');
        $end    = $this->input->post('end');
        $cmp_id   = $this->input->post('cmp_id');
        $where = NULL;

        if($cmp_id != "0"){
            $where['req_company'] = $cmp_id;
        }

        if(strlen($start)> 7) {
            $start = $this->date_convert_to_miladi($start);
            $where['bf_date >='] = $start;
        }
        if(strlen($end)> 7) {
            $end = $this->date_convert_to_miladi($end);
            $where['bf_date <='] = $end;
        }



        if($req_company != "0"){
            $where['req_company'] = $req_company;
        }



        if($bf_status != "0"){
            $bf_status -= 1 ;
            $bf_status .= "" ;
            $where['bf_status'] = $bf_status;
        }
        $data = $this->barname_model->get_admin_barname_filter($where);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "بارنامه ای وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_company"] = $this->company_model->get_name_by_id($item->req_company);
                $row["req_code"] = $item->req_code;
                $row["bf_id"] = $item->bf_id;
                $row["bf_price"] = $item->bf_price;
                $row["bf_reqid"] = $item->bf_reqid;

                $row["bf_date"] =  $this->date_convert($item->bf_date);
                $row["bf_cancell_time"] = "";
                $row["bf_peyment_date"] = "";
                $row["bf_driverid"] = $this->drivers_model->get_driver_name($item->bf_driverid);
                if($item->bf_status == "2"){
                    $row["bf_peyment_date"] = $this->date_convert($item->bf_peyment_date);
                    $row["bf_status"] = "پرداخت شده";
                }

                if($item->bf_status != "2" && $item->bf_status != "1"){
                    $row["bf_cancell_time"] = $this->date_convert($item->bf_cancell_time);
                    $row["bf_status"] = "کنسل شده";
                }

                if($item->bf_status == "1"){
                    $row["bf_status"] = "در انتظار پرداخت";
                }


                $row["bf_time_peyment"] = $item->bf_time_peyment;
                $row["bf_code"] = $item->bf_code;
                $jsonData["barname"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }//cmp_barname
    function admin_barname(){
        $this->load->model('barname_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');


        $cmp_id   = $this->input->post('cmp_id');
        $data = $this->barname_model->get_admin_barname($cmp_id);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "بارنامه ای وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_company"] = $this->company_model->get_name_by_id($item->req_company);
                $row["req_code"] = $item->req_code;
                $row["bf_id"] = $item->bf_id;
                $row["bf_price"] = $item->bf_price;
                $row["bf_reqid"] = $item->bf_reqid;

                $row["bf_date"] =  $this->date_convert($item->bf_date);
                $row["bf_cancell_time"] = "";
                $row["bf_peyment_date"] = "";
                $row["bf_driverid"] = $this->drivers_model->get_driver_name($item->bf_driverid);
                if($item->bf_status == "2"){
                    $row["bf_peyment_date"] = $this->date_convert($item->bf_peyment_date);
                    $row["bf_status"] = "پرداخت شده";
                }

                if($item->bf_status != "2" && $item->bf_status != "1"){
                    $row["bf_cancell_time"] = $this->date_convert($item->bf_cancell_time);
                    $row["bf_status"] = "کنسل شده";
                }

                if($item->bf_status == "1"){
                    $row["bf_status"] = "در انتظار پرداخت";
                }


                $row["bf_time_peyment"] = $item->bf_time_peyment;
                $row["bf_code"] = $item->bf_code;
                $jsonData["barname"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }//cmp_barname
    function cmp_barname(){
        $this->load->model('barname_model');
        $this->load->model('travelcompany/drivers_model');
        $cmp_id = $this->input->post('cmp_id');
        $data = $this->barname_model->get_company_barname($cmp_id);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "تراکنشی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_code"] = $item->req_code;
                $row["bf_id"] = $item->bf_id;
                $row["bf_price"] = $item->bf_price;
                $row["bf_reqid"] = $item->bf_reqid;

                $row["bf_date"] =  $this->date_convert($item->bf_date);
                $row["bf_cancell_time"] = "";
                $row["bf_peyment_date"] = "";
                $row["bf_driverid"] = "غیر قابل مشاهده";
                if($item->bf_status == "2"){
                    $row["bf_peyment_date"] = $this->date_convert($item->bf_peyment_date);
                    $row["bf_driverid"] = $this->drivers_model->get_driver_name($item->bf_driverid);
                    $row["bf_status"] = "پرداخت شده";
                }

                if($item->bf_status != "2" && $item->bf_status != "1"){
                    $row["bf_cancell_time"] = $this->date_convert($item->bf_cancell_time);
                    $row["bf_status"] = "کنسل شده";
                }

                if($item->bf_status == "1"){
                    $row["bf_status"] = "در انتظار پرداخت";
                }


                $row["bf_time_peyment"] = $item->bf_time_peyment;
                $row["bf_code"] = $item->bf_code;
                $jsonData["barname"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }//cmp_barname
    function admin_requests(){
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $this->load->model('setting_model');
        $this->load->model('travelcompany/company_model');
        $data = $this->requests_model->get("*" , NULL , "100" , NULL , "req_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "تراکنشی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_code"] = $item->req_code;
                $row["req_company"] = $this->company_model->get_name_by_id($item->req_company);
                $row["req_bar_price"] = $item->req_bar_price;
                $row["req_barname_price"] = $item->req_barname_price;
                $row["req_date"] = $this->date_convert($item->req_date);
                $row["req_address1"] = $item->req_city1 . " " . $item->req_address1;
                $row["req_address2"] = $item->req_city2 . " " . $item->req_address2;
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] = $this->setting_model->get_setting_name($item->req_bar_vazn);
                $row["req_bar_device"] = $this->setting_model->get_setting_name($item->req_bar_device);

                switch ($item->req_status){
                    case "0":
                        $row["req_status"] = "کنسل شده";
                        break;
                    case "1":
                        $row["req_status"] = "دریافت پیشنهاد";
                        break;
                    case "2":
                        $row["req_status"] = "پذیرش درخواست";
                        break;
                    case "3":
                        $row["req_status"] = "حرکت به سمت مبدا";
                        break;
                    case "4":
                        $row["req_status"] = "در حال بارگیری";
                        break;
                    case "5":
                        $row["req_status"] = "حرکت به سمت مقصد";
                        break;
                    case "6":
                        $row["req_status"] = "پایان یافته";
                        break;

                }


                $jsonData["requests"][] = $row;
            }
        }
        echo json_encode($jsonData);

    }//admin_requests
    function cmp_requests(){
        $this->load->model('main/requests_model');
        $this->load->model('driver_suggestion_model');
        $this->load->model('setting_model');
        $this->load->model('travelcompany/company_model');
        $cmp_id = $this->input->post('cmp_id');
        $where['req_company'] = $cmp_id;
        $data = $this->requests_model->get("*" , $where , "100" , NULL , "req_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "تراکنشی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_bar_admin"] = $item->req_bar_admin;
                $row["req_code"] = $item->req_code;
                $row["req_company"] = $this->company_model->get_name_by_id($item->req_company);
                $row["req_bar_price"] = $item->req_bar_price;
                $row["req_barname_price"] = $item->req_barname_price;
                $row["req_date"] = $this->date_convert($item->req_date);
                $row["req_address1"] = $item->req_city1 . " " . $item->req_address1;
                $row["req_address2"] = $item->req_city2 . " " . $item->req_address2;
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] = $this->setting_model->get_setting_name($item->req_bar_vazn);
                $row["req_bar_device"] = $this->setting_model->get_setting_name($item->req_bar_device);

                switch ($item->req_status){
                    case "0":
                        $row["req_status"] = "کنسل شده";
                        break;
                    case "1":
                        $row["req_status"] = "اعلام اولیه";
                        break;
                    case "2":
                        $row["req_status"] = "پذیرش درخواست";
                        break;
                    case "3":
                        $row["req_status"] = "حرکت به سمت مبدا";
                        break;
                    case "4":
                        $row["req_status"] = "در حال بارگیری";
                        break;
                    case "5":
                        $row["req_status"] = "حرکت به سمت مقصد";
                        break;
                    case "6":
                        $row["req_status"] = "پایان یافته";
                        break;

                }

                $where_suggestion['ds_reqid'] = $item->req_id;
                $res_sug = $this->driver_suggestion_model->get("ds_id",$where_suggestion);
                if(sizeof($res_sug) > 0 && $item->req_status =='1'){
                    $row["req_status"] = "  پیشنهاد دریافت شده  " . sizeof($res_sug);
                }


                $jsonData["requests"][] = $row;
            }
        }
        echo json_encode($jsonData);

    }//cmp_requests
    function company_rate_filter(){
        $this->load->model('rate_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('main/requests_model');


        $req_company  = $this->input->post('req_company');
        $req_status  = $this->input->post('req_status');
        $start   = $this->input->post('start');
        $end    = $this->input->post('end');
        $where = NULL;

        if(strlen($start)> 7) {
            $start = $this->date_convert_to_miladi($start);
            $where['rate_date >='] = $start;
        }
        if(strlen($end)> 7) {
            $end = $this->date_convert_to_miladi($end);
            $where['rate_date <='] = $end;
        }

        if($req_company != "0"){
            $where['req_company'] = $req_company;
        }

        if($req_status != "0"){
            $where['rate_number'] = $req_status;
        }




        $data = $this->rate_model->get_join_req("*" , $where , NULL , NULL , "rate_id desc" , 'req_id');
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "امتیازی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["rate_id"] = $item->rate_id;
                $row["rate_dess"] = $item->rate_dess;
                $row["rate_number"] = $item->rate_number;
                $row["rate_detail"] = $item->rate_detail;
                $row["rate_driverid"] = $this->drivers_model->get_driver_name($item->rate_driverid);
                $row["rate_reqid"] = $item->rate_reqid;
                $row["rate_date"] = $this->date_convert($item->rate_date);
                $cmp_id = $this->requests_model->get_cmp_id($item->rate_reqid);
                $req_code = $this->requests_model->get_req_code($item->rate_reqid);
                $row["req_company"] = $this->company_model->get_name_by_id($cmp_id);
                $row["req_code"] = $req_code;
                $jsonData["rate"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }
    function company_rate(){
        $this->load->model('rate_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('main/requests_model');
        $data = $this->rate_model->get("*" , NULL , "100" , NULL , "rate_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "امتیازی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["rate_id"] = $item->rate_id;
                $row["rate_dess"] = $item->rate_dess;
                $row["rate_number"] = $item->rate_number;
                $row["rate_detail"] = $item->rate_detail;
                $row["rate_driverid"] = $this->drivers_model->get_driver_name($item->rate_driverid);
                $row["rate_reqid"] = $item->rate_reqid;
                $row["rate_date"] = $this->date_convert($item->rate_date);
                $cmp_id = $this->requests_model->get_cmp_id($item->rate_reqid);
                $req_code = $this->requests_model->get_req_code($item->rate_reqid);
                $row["req_company"] = $this->company_model->get_name_by_id($cmp_id);
                $row["req_code"] = $req_code;
                $jsonData["rate"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }
    function set_driver_rate(){
        $this->load->model('rate_cmp_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('main/requests_model');

        $req_id  = $this->input->post('req_id');
        $where['req_id'] = $req_id;
        $data = $this->requests_model->get('req_status , req_driverid , req_company' , $where);
        if(empty($data)){
            $jsonData["status"] = "error";
            $jsonData["message"] = "صفحه را رفرش کنید";
        }else{
            $req_status = $data[0]->req_status;
            if ($req_status == "6") {
                $driverid = $data[0]->req_driverid;
                $req_company = $data[0]->req_company;
                $rate_number = $this->input->post('rate_number');
                $rate_detail = $this->input->post('rate_detail');

                $where_rate['rc_reqid'] = $req_id;
                $data_rate['rc_reqid'] = $req_id;
                $data_rate['rc_cmp_id'] = $req_company;
                $data_rate['rc_number'] = $rate_number;
                $data_rate['rc_driverid'] = $driverid;
                $data_rate['rc_des'] = $rate_detail;
                $data_rate['rc_detail'] = "0";
                $data_first = $this->rate_cmp_model->get("rc_id",$where_rate);
                if(empty($data_first)) {
                    if ($this->rate_cmp_model->insert($data_rate)) {
                        $jsonData["status"] = "ok";
                    } else {
                        $jsonData["status"] = "error";
                        $jsonData["message"] = "دوباره امتحان کنید";
                    }
                }else{
                    $jsonData["status"] = "error";
                    $jsonData["message"] = "شما قبلا امتیاز داده اید";
                }
            }else{
                $jsonData["status"] = "error";
                $jsonData["message"] = "بعد از اتمام درخواست میتوانید امتیاز دهید";
            }
        }

        echo json_encode($jsonData);
    }//set_driver_rate
    function driver_rate(){
        $this->load->model('rate_cmp_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('main/requests_model');
        $data = $this->rate_cmp_model->get("*" , NULL , "100" , NULL , "rc_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "امتیازی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["rc_id"] = $item->rc_id;
                $row["rc_reqid"] = $item->rc_reqid;
                $row["rc_number"] = $item->rc_number;
                $row["rc_driverid"] = $this->drivers_model->get_driver_name($item->rc_driverid);
                $row["rc_des"] = $item->rc_des;
                $row["rc_detail"] = $item->rc_detail;
                $row["rc_date"] = $this->date_convert($item->rc_date);
                $req_code = $this->requests_model->get_req_code($item->rc_reqid);
                $row["rc_cmp_id"] = $this->company_model->get_name_by_id($item->rc_cmp_id);
                $row["req_code"] = $req_code;
                $jsonData["rate"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }
    function driver_rate_filter(){
        $this->load->model('rate_cmp_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('main/requests_model');


        $req_company  = $this->input->post('req_company');
        $req_status  = $this->input->post('req_status');
        $start   = $this->input->post('start');
        $end    = $this->input->post('end');
        $where = NULL;

        if(strlen($start)> 7) {
            $start = $this->date_convert_to_miladi($start);
            $where['rc_date >='] = $start;
        }
        if(strlen($end)> 7) {
            $end = $this->date_convert_to_miladi($end);
            $where['rc_date <='] = $end;
        }

        if($req_company != "0"){
            $where['rc_cmp_id'] = $req_company;
        }

        if($req_status != "0"){
            $where['rc_number'] = $req_status;
        }




        $data = $this->rate_cmp_model->get("*" , $where , NULL , NULL , "rc_id desc" );
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "امتیازی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["rc_id"] = $item->rc_id;
                $row["rc_reqid"] = $item->rc_reqid;
                $row["rc_number"] = $item->rc_number;
                $row["rc_driverid"] = $this->drivers_model->get_driver_name($item->rc_driverid);
                $row["rc_des"] = $item->rc_des;
                $row["rc_detail"] = $item->rc_detail;
                $row["rc_date"] = $this->date_convert($item->rc_date);
                $req_code = $this->requests_model->get_req_code($item->rc_reqid);
                $row["rc_cmp_id"] = $this->company_model->get_name_by_id($item->rc_cmp_id);
                $row["req_code"] = $req_code;
                $jsonData["rate"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }
    function admin_requests_filter(){
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $this->load->model('setting_model');
        $this->load->model('driver_suggestion_model');
        $this->load->model('travelcompany/company_model');

        $req_company  = $this->input->post('req_company');
        $req_status  = $this->input->post('req_status');
        $req_bar_kind   = $this->input->post('req_bar_kind');
        $req_bar_device    = $this->input->post('req_bar_device');
        $req_bar_packet    = $this->input->post('req_bar_packet');
        $req_bar_vazn   = $this->input->post('req_bar_vazn');
        $req_takhlie   = $this->input->post('req_takhlie');
        $start   = $this->input->post('start');
        $end    = $this->input->post('end');
        $where = NULL;

        if(strlen($start)> 7) {
            $start = $this->date_convert_to_miladi($start);
            $where['req_date >='] = $start;
        }
        if(strlen($end)> 7) {
            $end = $this->date_convert_to_miladi($end);
            $where['req_date <='] = $end;
        }

        if($req_company != "0"){
            $where['req_company'] = $req_company;
        }

        if($req_status != "0"){
            $req_status -= 1 ;
            $req_status .= "" ;
            $where['req_status'] = $req_status;
        }

        if($req_bar_kind != "0"){
            $where['req_bar_kind'] = $req_bar_kind;
        }

        if($req_bar_device != "0"){
            $where['req_bar_device'] = $req_bar_device;
        }

        if($req_bar_packet!= "0"){
            $where['req_bar_packet'] = $req_bar_packet;
        }

        if($req_bar_vazn != "0"){
            $where['req_bar_vazn'] = $req_bar_vazn;
        }

        if($req_takhlie != "0"){
            $where['req_takhlie'] = $req_takhlie;
        }

//        var_dump($where);

        $data = $this->requests_model->get("*" , $where , NULL , NULL , "req_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_bar_admin"] = $item->req_bar_admin;
                $row["req_code"] = $item->req_code;
                $row["req_company"] = $this->company_model->get_name_by_id($item->req_company);
                $row["req_bar_price"] = $item->req_bar_price;
                $row["req_barname_price"] = $item->req_barname_price;
                $row["req_date"] = $this->date_convert($item->req_date);
                $row["req_address1"] = $item->req_city1 . " " . $item->req_address1;
                $row["req_address2"] = $item->req_city2 . " " . $item->req_address2;
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] = $this->setting_model->get_setting_name($item->req_bar_vazn);
                $row["req_bar_device"] = $this->setting_model->get_setting_name($item->req_bar_device);

                switch ($item->req_status){
                    case "0":
                        $row["req_status"] = "کنسل شده";
                        break;
                    case "1":
                        $row["req_status"] = "اعلام اولیه";
                        break;
                    case "2":
                        $row["req_status"] = "پذیرش درخواست";
                        break;
                    case "3":
                        $row["req_status"] = "حرکت به سمت مبدا";
                        break;
                    case "4":
                        $row["req_status"] = "در حال بارگیری";
                        break;
                    case "5":
                        $row["req_status"] = "حرکت به سمت مقصد";
                        break;
                    case "6":
                        $row["req_status"] = "پایان یافته";
                        break;

                }

                $where_suggestion['ds_reqid'] = $item->req_id;
                $res_sug = $this->driver_suggestion_model->get("ds_id",$where_suggestion);
                if(sizeof($res_sug) > 0){
                    $row["req_status"] = "  پیشنهاد دریافت شده  " . sizeof($res_sug);
                }


                $jsonData["requests"][] = $row;
            }
        }
        echo json_encode($jsonData);

    }//admin_requests_filter
    function send_sms_company_register($mobile = '09120917577', $code = '332211')
    {
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverVerify");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
    }// end of sendSms
    function date_convert($miladi_date)
    {
        error_reporting(0);
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/") . " " . $explode_date_time[1];
    }//end of date_convert function
    function date_convert_to_miladi($shamsi_date)
    {
        error_reporting(0);
        $this->load->library('jdf');
        $explode_date = explode("-", $shamsi_date);
        return $this->jdf->jalali_to_gregorian($explode_date[0], $explode_date[1], $explode_date[2], "-");

    }//end of date_convert function
    function valid_shaba($shaba = '040120010000004776518291') {
        if (strlen($shaba) == 24) {
            $plite = str_split($shaba);
            $shaba_change1 = $shaba . '1827' . $plite[0] . $plite[1];
            $shaba_change1 = substr($shaba_change1, 1);
            $shaba_change1 = substr($shaba_change1, 1);
            if (bcmod($shaba_change1, '97') == 1) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }//validshaba
    function AbrlineToken(){
        $URL = "https://abrlife.com/api/v2/business/login";
        $data = array('username' => 'tdriver', 'password' => '!@#tdriver.admin');

        $options = array(
            'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data)
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($URL, false, $context);
        if ($result === FALSE) {

            return 0;
        }else{
            $result_json = json_decode($result);
            $code = $result_json->status->code ;
            $description = $result_json->status->description ;
            if($code == 200 && $description == 'success'){
                $id = $result_json->data->business->_id ;
                $token = $result_json->data->token ;
                return $token;
            }else{
                $data = $result_json->data ;
                $out['status'] = "OK";
                $out['message'] = $data;
                return 0;
            }
        }
    }//Abrlife_login
    function get_transactions(){

        $Authorization = $this->AbrlineToken();
        $customer_id = "tdriver/09031236525";
        $start_day = "1538761700000";
        $end_day   = "1546185322000";
        $type = "transfer";

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/usertransaction?customer_id=".$customer_id."&start_date=".$start_day."&end_date=".$end_day."&type=".$type,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_POSTFIELDS => "{\n\t\"type\":\"$type\",\n\t\"start_date\":\"$start_day\",\n\t\"end_day\":\"$end_day\",\n\t\"customer_id\":\"$customer_id\"\n}",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Content-Type: application/json",
                "Postman-Token: db34603b-a0e9-4986-9b07-727cb319e35c",
                "cache-control: no-cache"
            ),
        ));


        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);
        if ($err) {
            $jsonData['status'] = "error";
            $jsonData['message'] = $err;
        } else {
            $jsonData['res'] = json_decode($response);
        }
        echo json_encode($jsonData);
    }//get_transactions
    function app_register_balance(){
        $this->load->model('travelcompany/company_model');

        $username = $this->input->post("mobile");
        $cellphone = $this->input->post("mobile");
        $shaba = $this->input->post("shaba");
        $email = $this->input->post("email");
        $name = $this->input->post("name");
        $national_code = $this->input->post("melli");
        $cmp_id = $this->input->post("cmp_id");
        $Authorization = $this->AbrlineToken();


        if($this->valid_shaba($shaba)) {
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://abrlife.com/api/v2/business/registeruser",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => "{\n\t\"username\":\"$username\",\n\t\"cellphone\":\"$cellphone\",\n\t\"shaba\":\"$shaba\",\n\t\"email\":\"$email\",\n\t\"name\":\"$name\",\n\t\"national_code\":\"$national_code\"\n}",
                CURLOPT_HTTPHEADER => array(
                    "Authorization: " . $Authorization,
                    "Content-Type: application/json",
                    "Postman-Token: db34603b-a0e9-4986-9b07-727cb319e35c",
                    "cache-control: no-cache"
                ),
            ));

            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
                $jsonData['status'] = "error";
                $jsonData['message'] = $err;
            } else {
                $result_json = json_decode($response);
                $status = $result_json->status->description;

                if($status == "success"){

                    $where_acount['cmp_id']= $cmp_id;
                    $date_acount['cmp_customer_id']=$result_json->data->user->customer_id;
                    if($this->company_model->update($where_acount,$date_acount)){
                        $jsonData['status'] = "OK";
                        $jsonData['message'] = $result_json->data->user->customer_id;
                    }else{
                        if($this->company_model->update($where_acount,$date_acount)) {
                            $jsonData['status'] = "OK";
                            $jsonData['message'] = $result_json->data->user->customer_id;
                        }else{
                            if($this->company_model->update($where_acount,$date_acount)) {
                                $jsonData['status'] = "OK";
                                $jsonData['message'] = $result_json->data->user->customer_id;
                            }else{
                                $jsonData['status'] = "error";
                                $jsonData['message'] = $this->company_model->update($where_acount,$date_acount);
                            }
                        }
                    }


                    $where_cmp_shaba['cmp_id'] = $cmp_id;
                    $data_cmp_shaba['cmp_shaba'] = $shaba;
                    $this->company_model->update($where_cmp_shaba,$data_cmp_shaba);


                }else{
                    $jsonData['status'] = "error";
                    if($result_json->data == 'duplicate user'){
                        $jsonData['message'] = 'شماره وارد شده تکراری است';
                    }else{
                        $jsonData['message'] = $result_json->data;
                    }
                }
            }

        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره شبا معتبر نمی باشد";
        }
        echo json_encode($jsonData);
    }
    function cancell_trip(){
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');

        $req_id = $this->input->post("req_id");
        $status = $this->barname_model->allow_peyment_cancell($req_id);
//        echo $status;
        if($status == "0"){
            if($this->requests_model->cancell_trip($req_id)){
                $jsonData['status'] = "OK";
            }else{
                $jsonData['status'] = "error";
                $jsonData['message'] = "دوباره امتحان کنید";
            }
        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = "امکان لغو این درخواست وجود ندارد";
        }
        echo json_encode($jsonData);
    }//cancell_trip
    function cmp_info(){
        $this->load->model('travelcompany/company_model');
        $cmp_id = $this->input->post("cmp_id");
        $cmp_name = $this->company_model->get_name_by_id($cmp_id);
        $cmp_credit = $this->company_model->get_company_credit($cmp_id);
        $jsonData['cmp_name'] = $cmp_name;
        $jsonData['cmp_credit'] = $cmp_credit;
        echo json_encode($jsonData);
    }//cmp_info
    function cmp_tasvieh(){
        $this->load->model('company_transaction_model');
        $this->load->model('travelcompany/company_model');
        $cmp_id = $this->input->post("cmp_id");
        $amount = $this->input->post("amount");
        $customer_id = $this->company_model->get_customer_id($cmp_id);
        $res = $this->company_model->company_tasvieh($customer_id , $amount);
        if($res == "OK"){

            $amount = $amount/10;
            $data_cmpt['cmpt_kind']="3";
            $data_cmpt['cmpt_price']=$amount;
            $data_cmpt['cmpt_req_id']="";
            $data_cmpt['cmpt_cmp_id']=$cmp_id;
            $this->company_transaction_model->insert($data_cmpt);



            $jsonData['status'] = "OK";
        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = $res;
        }
        echo json_encode($jsonData);
    }//cmp_info


    function cmp_transaction(){
            $this->load->model('company_transaction_model');
            $cmp_id = $this->input->post("cmp_id");
            $where['cmpt_cmp_id']=$cmp_id;
            $data = $this->company_transaction_model->get("*" , $where , NULL , NULL , "cmpt_id desc");
            if(empty($data)){
                $jsonData['status'] = "error";
                $jsonData['message'] = "درخواستی وجود ندارد";
            }else {
                $jsonData['status'] = "ok";
                foreach ($data as $item) {
                    $row = array();
                    $row["cmpt_id"] = $item->cmpt_id;
                    $row["cmpt_price"] = $item->cmpt_price;
                    $row["cmpt_date"] = $this->date_convert($item->cmpt_date);
                    $row["cmp_dess"] = $item->cmp_dess;
                    $row["cmpt_cmp_id"] = $item->cmpt_cmp_id;
                    $row["cmpt_req_id"] = $item->cmpt_req_id;


                    switch ($item->cmpt_kind){
                        case "1":
                            $row["cmpt_kind"] = " افزایش موجودی - پرداخت بارنامه ";
                            break;
                        case "2":
                            $row["cmpt_kind"] = "کاهش موجودی - کسر کمیسیون ";
                            break;
                        case "3":
                            $row["cmpt_kind"] = "کاهش موجودی - تسویه حساب";
                            break;
                    }

                    $jsonData["requests"][] = $row;


                }
            }
            echo json_encode($jsonData);
    }//cmp_transaction



    function cmp_transaction_filter(){
        $this->load->model('company_transaction_model');
        $this->load->model('travelcompany/company_model');

        $cmpt_kind = $this->input->post("cmpt_kind");
        $start = $this->input->post("start");
        $end = $this->input->post("end");

        $cmp_id = $this->input->post("cmp_id");
        $where['cmpt_cmp_id']=$cmp_id;

        if($cmpt_kind != "0")
            $where['cmpt_kind']=$cmpt_kind;

        if(strlen($start)> 7) {
            $start = $this->date_convert_to_miladi($start);
            $where['cmpt_date >='] = $start;
        }
        if(strlen($end)> 7) {
            $end = $this->date_convert_to_miladi($end);
            $where['cmpt_date <='] = $end;
        }


        $data = $this->company_transaction_model->get("*" , $where , NULL , NULL , "cmpt_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["cmpt_id"] = $item->cmpt_id;
                $row["cmpt_price"] = $item->cmpt_price;
                $row["cmpt_date"] = $this->date_convert($item->cmpt_date);
                $row["cmp_dess"] = $item->cmp_dess;
                $row["cmpt_cmp_id"] = $this->company_model->get_name_by_id($item->cmpt_cmp_id);
                $row["cmpt_req_id"] = $item->cmpt_req_id;


                switch ($item->cmpt_kind){
                    case "1":
                        $row["cmpt_kind"] = " افزایش موجودی - پرداخت بارنامه ";
                        break;
                    case "2":
                        $row["cmpt_kind"] = "کاهش موجودی - کسر کمیسیون ";
                        break;
                    case "3":
                        $row["cmpt_kind"] = "کاهش موجودی - تسویه حساب";
                        break;
                }

                $jsonData["requests"][] = $row;


            }
        }
        echo json_encode($jsonData);
    }//cmp_transaction



    function cmp_transaction_all(){
        $this->load->model('company_transaction_model');
        $this->load->model('travelcompany/company_model');

        $data = $this->company_transaction_model->get("*" , NULL , NULL , NULL , "cmpt_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["cmpt_id"] = $item->cmpt_id;
                $row["cmpt_price"] = $item->cmpt_price;
                $row["cmpt_date"] = $this->date_convert($item->cmpt_date);
                $row["cmp_dess"] = $item->cmp_dess;
                $row["cmpt_cmp_id"] = $this->company_model->get_name_by_id($item->cmpt_cmp_id);
                $row["cmpt_req_id"] = $item->cmpt_req_id;


                switch ($item->cmpt_kind){
                    case "1":
                        $row["cmpt_kind"] = " افزایش موجودی - پرداخت بارنامه ";
                        break;
                    case "2":
                        $row["cmpt_kind"] = "کاهش موجودی - کسر کمیسیون ";
                        break;
                    case "3":
                        $row["cmpt_kind"] = "کاهش موجودی - تسویه حساب";
                        break;
                }

                $jsonData["requests"][] = $row;


            }
        }
        echo json_encode($jsonData);
    }//cmp_transaction


    function driver_transaction_all(){
        $this->load->model('driver_transaction_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('travelcompany/drivers_model');

        $data = $this->driver_transaction_model->get("*" , NULL , "50" , NULL , "dt_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["dt_id"] = $item->dt_id;
                $row["dt_driverid"] = $this->drivers_model->get_driver_name($item->dt_driverid);
                $row["dt_status"] = $item->dt_status;
                $row["dt_price"] = $item->dt_price;
                $row["dt_new_credit"] = $item->dt_new_credit;
                $row["dt_date"] = $this->date_convert($item->dt_date);
                $row["dt_code1"] = $item->dt_code1;
                $row["dt_code2"] = $item->dt_code2;
                $row["dt_code3"] = $item->dt_code3;
                $row["dt_company"] = $this->drivers_model->get_company_name_by_driverid($item->dt_driverid);
//                $row["cmpt_cmp_id"] = $this->company_model->get_name_by_id($item->cmpt_cmp_id);
//                $row["cmpt_req_id"] = $item->cmpt_req_id;


                switch ($item->dt_kind){
                    case "1":
                        $row["dt_kind"] = "هدیه ثبت نام";
                        break;
                    case "2":
                        $row["dt_kind"] = "";
                        break;
                    case "3":
                        $row["dt_kind"] = "پرداخت بارنامه";
                        break;
                    case "4":
                        $row["dt_kind"] = "پرداخت کمسیون";
                        break;
                    case "5":
                        $row["dt_kind"] = "";
                        break;
                    case "6":
                        $row["dt_kind"] = "کسب درآمد از انجام سفر";
                        break;
                }

                $jsonData["requests"][] = $row;


            }
        }
        echo json_encode($jsonData);
    }//cmp_transaction



    function driver_transaction_filter(){
        $this->load->model('driver_transaction_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('travelcompany/drivers_model');

        $driver_name = $this->input->post("driver_name");
        $cmpt_kind = $this->input->post("cmpt_kind");
        $start = $this->input->post("start");
        $end = $this->input->post("end");

//        $cmp_id = $this->input->post("cmp_id");
//        $where['cmpt_cmp_id']=$cmp_id;

        if($cmpt_kind != "0")
            $where['dt_kind']=$cmpt_kind;

        if(strlen($start)> 7) {
            $start = $this->date_convert_to_miladi($start);
            $where['dt_date >='] = $start;
        }
        if(strlen($end)> 7) {
            $end = $this->date_convert_to_miladi($end);
            $where['dt_date <='] = $end;
        }


        $data = $this->driver_transaction_model->get("*" , $where , NULL , NULL , "dt_id desc");
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["dt_id"] = $item->dt_id;
                $row["dt_driverid"] = $this->drivers_model->get_driver_name($item->dt_driverid);
                $row["dt_status"] = $item->dt_status;
                $row["dt_price"] = $item->dt_price;
                $row["dt_new_credit"] = $item->dt_new_credit;
                $row["dt_date"] = $this->date_convert($item->dt_date);
                $row["dt_code1"] = $item->dt_code1;
                $row["dt_code2"] = $item->dt_code2;
                $row["dt_code3"] = $item->dt_code3;
                $row["dt_company"] = $this->drivers_model->get_company_name_by_driverid($item->dt_driverid);
//                $row["cmpt_cmp_id"] = $this->company_model->get_name_by_id($item->cmpt_cmp_id);
//                $row["cmpt_req_id"] = $item->cmpt_req_id;


                switch ($item->dt_kind){
                    case "1":
                        $row["dt_kind"] = "هدیه ثبت نام";
                        break;
                    case "2":
                        $row["dt_kind"] = "";
                        break;
                    case "3":
                        $row["dt_kind"] = "پرداخت بارنامه";
                        break;
                    case "4":
                        $row["dt_kind"] = "پرداخت کمسیون";
                        break;
                    case "5":
                        $row["dt_kind"] = "";
                        break;
                    case "6":
                        $row["dt_kind"] = "کسب درآمد از انجام سفر";
                        break;
                }

                $jsonData["requests"][] = $row;


            }
        }
        echo json_encode($jsonData);
    }//cmp_transaction

}//end of class
