<?php /* In The Name Of Allah */

/** Software Hijri_Shamsi , Solar(Jalali) Date and Time
Copyright(C)2011, Reza Gholampanahi , http://jdf.scr.ir
version 2.55 :: 1391/08/24 = 1433/12/18 = 2012/11/15 */

class Jdf{
	
	/*	F	*/
	function tr_num($str,$mod='en',$mf='٫'){
	 $num_a=array('0','1','2','3','4','5','6','7','8','9','.');
	 $key_a=array('۰','۱','۲','۳','۴','۵','۶','۷','۸','۹',$mf);
	 return($mod=='fa')?str_replace($num_a,$key_a,$str):str_replace($key_a,$num_a,$str);
	}

	
	/*	F	*/
	function gregorian_to_jalali($g_y,$g_m,$g_d,$mod=''){
		$g_y=$this->tr_num($g_y); $g_m=$this->tr_num($g_m); $g_d=$this->tr_num($g_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
	 $d_4=$g_y%4;
	 $g_a=array(0,0,31,59,90,120,151,181,212,243,273,304,334);
	 $doy_g=$g_a[(int)$g_m]+$g_d;
	 if($d_4==0 and $g_m>2)$doy_g++;
	 $d_33=(int)((($g_y-16)%132)*.0305);
	 $a=($d_33==3 or $d_33<($d_4-1) or $d_4==0)?286:287;
	 $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
	 if((int)(($g_y-10)/63)==30){$a--;$b++;}
	 if($doy_g>$b){
	  $jy=$g_y-621; $doy_j=$doy_g-$b;
	 }else{
	  $jy=$g_y-622; $doy_j=$doy_g+$a;
	 }
	 if($doy_j<187){
	  $jm=(int)(($doy_j-1)/31); $jd=$doy_j-(31*$jm++);
	 }else{
	  $jm=(int)(($doy_j-187)/30); $jd=$doy_j-186-($jm*30); $jm+=7;
	 }
	 return($mod=='')?array($jy,$jm,$jd):$jy.$mod.$jm.$mod.$jd;
	}

	/*	F	*/
	function jalali_to_gregorian($j_y,$j_m,$j_d,$mod=''){
		$j_y=$this->tr_num($j_y); $j_m=$this->tr_num($j_m); $j_d=$this->tr_num($j_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
	 $d_4=($j_y+1)%4;
	 $doy_j=($j_m<7)?(($j_m-1)*31)+$j_d:(($j_m-7)*30)+$j_d+186;
	 $d_33=(int)((($j_y-55)%132)*.0305);
	 $a=($d_33!=3 and $d_4<=$d_33)?287:286;
	 $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
	 if((int)(($j_y-19)/63)==20){$a--;$b++;}
	 if($doy_j<=$a){
	  $gy=$j_y+621; $gd=$doy_j+$b;
	 }else{
	  $gy=$j_y+622; $gd=$doy_j-$a;
	 }
	 foreach(array(0,31,($gy%4==0)?29:28,31,30,31,30,31,31,30,31,30,31) as $gm=>$v){
	  if($gd<=$v)break;
	  $gd-=$v;
	 }
	 return($mod=='')?array($gy,$gm,$gd):$gy.$mod.$gm.$mod.$gd;
	}


  function gregorian_to_jalali_month($g_y,$g_m,$g_d,$mod=''){
    $g_y=$this->tr_num($g_y); $g_m=$this->tr_num($g_m); $g_d=$this->tr_num($g_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
    $d_4=$g_y%4;
    $g_a=array(0,0,31,59,90,120,151,181,212,243,273,304,334);
    $doy_g=$g_a[(int)$g_m]+$g_d;
    if($d_4==0 and $g_m>2)$doy_g++;
    $d_33=(int)((($g_y-16)%132)*.0305);
    $a=($d_33==3 or $d_33<($d_4-1) or $d_4==0)?286:287;
    $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
    if((int)(($g_y-10)/63)==30){$a--;$b++;}
    if($doy_g>$b){
      $jy=$g_y-621; $doy_j=$doy_g-$b;
    }else{
      $jy=$g_y-622; $doy_j=$doy_g+$a;
    }
    if($doy_j<187){
      $jm=(int)(($doy_j-1)/31); $jd=$doy_j-(31*$jm++);
    }else{
      $jm=(int)(($doy_j-187)/30); $jd=$doy_j-186-($jm*30); $jm+=7;
    }
    return($mod=='')?array($jy,$jm,"1"):$jy.$mod.$jm.$mod."1";
  }


  function gregorian_to_jalali_first($g_y,$g_m,$g_d,$mod=''){
    $g_y=$this->tr_num($g_y); $g_m=$this->tr_num($g_m); $g_d=$this->tr_num($g_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
    $d_4=$g_y%4;
    $g_a=array(0,0,31,59,90,120,151,181,212,243,273,304,334);
    $doy_g=$g_a[(int)$g_m]+$g_d;
    if($d_4==0 and $g_m>2)$doy_g++;
    $d_33=(int)((($g_y-16)%132)*.0305);
    $a=($d_33==3 or $d_33<($d_4-1) or $d_4==0)?286:287;
    $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
    if((int)(($g_y-10)/63)==30){$a--;$b++;}
    if($doy_g>$b){
      $jy=$g_y-621; $doy_j=$doy_g-$b;
    }else{
      $jy=$g_y-622; $doy_j=$doy_g+$a;
    }
    if($doy_j<187){
      $jm=(int)(($doy_j-1)/31); $jd=$doy_j-(31*$jm++);
    }else{
      $jm=(int)(($doy_j-187)/30); $jd=$doy_j-186-($jm*30); $jm+=7;
    }
    return($mod=='')?array($jy,$jm,'1'):$jy.$mod.$jm.$mod.'1';
  }


  function gregorian_to_jalali_webservice($g_y,$g_m,$g_d,$mod='' , $day_plus){
    $g_y=$this->tr_num($g_y); $g_m=$this->tr_num($g_m); $g_d=$this->tr_num($g_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
    $d_4=$g_y%4;
    $g_a=array(0,0,31,59,90,120,151,181,212,243,273,304,334);
    $doy_g=$g_a[(int)$g_m]+$g_d;
    if($d_4==0 and $g_m>2)$doy_g++;
    $d_33=(int)((($g_y-16)%132)*.0305);
    $a=($d_33==3 or $d_33<($d_4-1) or $d_4==0)?286:287;
    $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
    if((int)(($g_y-10)/63)==30){$a--;$b++;}
    if($doy_g>$b){
      $jy=$g_y-621; $doy_j=$doy_g-$b;
    }else{
      $jy=$g_y-622; $doy_j=$doy_g+$a;
    }
    if($doy_j<187){
      $jm=(int)(($doy_j-1)/31); $jd=$doy_j-(31*$jm++);
    }else{
      $jm=(int)(($doy_j-187)/30); $jd=$doy_j-186-($jm*30); $jm+=7;
    }
    return($mod=='')?array($jy,$jm,(1+$day_plus)):$jy.$mod.$jm.$mod.(1+$day_plus);
  }

  function gregorian_to_jalali_webservice_month($g_y,$g_m,$g_d,$mod='' , $day_plus){
    $g_y=$this->tr_num($g_y); $g_m=$this->tr_num($g_m); $g_d=$this->tr_num($g_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
    $d_4=$g_y%4;
    $g_a=array(0,0,31,59,90,120,151,181,212,243,273,304,334);
    $doy_g=$g_a[(int)$g_m]+$g_d;
    if($d_4==0 and $g_m>2)$doy_g++;
    $d_33=(int)((($g_y-16)%132)*.0305);
    $a=($d_33==3 or $d_33<($d_4-1) or $d_4==0)?286:287;
    $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
    if((int)(($g_y-10)/63)==30){$a--;$b++;}
    if($doy_g>$b){
      $jy=$g_y-621; $doy_j=$doy_g-$b;
    }else{
      $jy=$g_y-622; $doy_j=$doy_g+$a;
    }
    if($doy_j<187){
      $jm=(int)(($doy_j-1)/31); $jd=$doy_j-(31*$jm++);
    }else{
      $jm=(int)(($doy_j-187)/30); $jd=$doy_j-186-($jm*30); $jm+=7;
    }
    return $jm;
  }// end of gregorian_to_jalali_webservice_month



  function get_expire_time($j_y,$j_m,$j_d,$mod=''){
    $j_y=$this->tr_num($j_y); $j_m=$this->tr_num($j_m); $j_d=$this->tr_num($j_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
    $d_4=($j_y+1)%4;
    $doy_j=($j_m<7)?(($j_m-1)*31)+$j_d:(($j_m-7)*30)+$j_d+186;
    $d_33=(int)((($j_y-55)%132)*.0305);
    $a=($d_33!=3 and $d_4<=$d_33)?287:286;
    $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
    if((int)(($j_y-19)/63)==20){$a--;$b++;}
    if($doy_j<=$a){
      $gy=$j_y+621; $gd=$doy_j+$b;
    }else{
      $gy=$j_y+622; $gd=$doy_j-$a;
    }
    foreach(array(0,31,($gy%4==0)?29:28,31,30,31,30,31,31,30,31,30,31) as $gm=>$v){
      if($gd<=$v)break;
      $gd-=$v;
    }
    return($mod=='')?array($gy,$gm,$gd):$gy.$mod.$gm.$mod.$gd;
  }

	
}
	