<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Barname_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('_barname_factor', $limit, $offset)->result();
	}//get
	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_barname_factor ', $data))
			return TRUE;
		else
			return FALSE;
	}//update
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_barname_factor'))
			return TRUE;
		else
			return FALSE;
	}
	function insert($data)
	{
		if($this->db->insert('_barname_factor', $data))
            return $this->db->insert_id();
		else
			return FALSE;
	}
    function get_company_barname($cmp_id)
    {
        $where['_requests.req_company'] = $cmp_id;
        $select = "*";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->where($where);
        $this->db->group_by($group_by);
        $this->db->order_by("bf_id desc");
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', "50", "0")->result();
        return $result;
    }//cmp_drivers_count
    function get_admin_barname($cmp_id)
    {
        $select = "*";
        $group_by = "bf_id";
        $this->db->select($select);
        if($cmp_id != "0"){
            $where['_requests.req_company'] = $cmp_id;
            $this->db->where($where);
        }
        $this->db->group_by($group_by);
        $this->db->order_by("bf_id desc");
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', "50", "0")->result();
        return $result;
    }//cmp_drivers_count
    function get_admin_barname_filter($where)
    {
        $select = "*";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->group_by($group_by);
        $this->db->where($where);
        $this->db->order_by("bf_id desc");
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', "50", "0")->result();
        return $result;
    }//cmp_drivers_count
    function barname_count()
    {
        $select = "bf_id";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->group_by($group_by);
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function cmp_barname_count($cmp_id)
    {
        $where['_requests.req_company'] = $cmp_id;
        $select = "bf_id";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->where($where);
        $this->db->group_by($group_by);
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function barname_count_pay()
    {
        $where['bf_status'] = "2";
        $select = "bf_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_barname_factor', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function cmp_barname_count_pay($cmp_id)
    {
        $where['_requests.req_company'] = $cmp_id;
        $where['bf_status'] = "2";
        $select = "bf_id";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->where($where);
        $this->db->group_by($group_by);
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function barname_count_pay_price()
    {
        $where['bf_status'] = "2";
        $select = "bf_price";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->group_by($group_by);
        $this->db->where($where);
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', NULL, NULL)->result();
        $total = 0 ;
        foreach ($result as $item){
            $total += $item->bf_price;
        }
        return $total;
    }//cmp_drivers_count
    function cmp_barname_count_pay_price($cmp_id)
    {
        $where['_requests.req_company'] = $cmp_id;
        $where['bf_status'] = "2";
        $select = "bf_price";
        $group_by = "bf_id";
        $this->db->select($select);
        $this->db->where($where);
        $this->db->group_by($group_by);
        $this->db->join('_requests', '_requests.req_id=_barname_factor.bf_reqid', 'left');
        $result = $this->db->get('_barname_factor', NULL, NULL)->result();
        $total = 0 ;
        foreach ($result as $item){
            $total += $item->bf_price;
        }
         return $total;
    }//cmp_drivers_count
    function get_barname_price($req_id , $driverid)
    {

        $where_r['req_id'] = $req_id;
        $select_r = "req_barname_id";
        $this->db->select($select_r);
        $this->db->where($where_r);
        $result_r = $this->db->get('_requests', NULL, NULL)->result();
        if(!empty($result_r)){
            $where['bf_reqid'] = $req_id;
            $where['bf_id'] = $result_r[0]->req_barname_id;
            $where['bf_driverid'] = $driverid;
            $select = "bf_price";
            $this->db->select($select);
            $this->db->where($where);
            $result = $this->db->get('_barname_factor', NULL, NULL)->result();
            if(empty($result)){
                return 0;
            }else{
                return $result[0]->bf_price;
            }
        }else{
            return 0;
        }
    }//get_barname_price

    function get_barname_bar_price($req_id , $driverid){
        $where_r['req_id'] = $req_id;
        $select_r = "req_barname_id";
        $this->db->select($select_r);
        $this->db->where($where_r);
        $result_r = $this->db->get('_requests', NULL, NULL)->result();
        if(!empty($result_r)){
            $where['bf_reqid'] = $req_id;
            $where['bf_id'] = $result_r[0]->req_barname_id;
            $where['bf_driverid'] = $driverid;
            $select = "bf_price_bar";
            $this->db->select($select);
            $this->db->where($where);
            $result = $this->db->get('_barname_factor', NULL, NULL)->result();
            if(empty($result)){
                return 0;
            }else{
                return $result[0]->bf_price_bar;
            }
        }else{
            return 0;
        }
    }









	function cancell_suggestion_by_driver($req_id,$driverid){
        date_default_timezone_set('Asia/Tehran');
	    $where['bf_reqid'] = $req_id;
	    $where['bf_driverid'] = $driverid;
        $date['bf_cancell_time'] = date('Y-m-d H:i:s', time());
	    $date['bf_status'] = "4";
	    if($this->update($where,$date)){
	        // sms_to_managment
            $this->sendSmd_cancell($req_id,"T-".$req_id , 1);
            return TRUE ;
        }else{
	        return FALSE ;
        }
    }//cancell_suggestion_by_driver
    function accept_suggestion_by_driver($req_id,$driverid){
        $this->load->model('main/requests_model');
        date_default_timezone_set('Asia/Tehran');
	    $where['bf_reqid'] = $req_id;
	    $where['bf_driverid'] = $driverid;
        $date['bf_cancell_time'] = date('Y-m-d H:i:s', time());
        $date['bf_peyment_date'] = date('Y-m-d H:i:s', time());
	    $date['bf_status'] = "2";
	    $date['bf_code'] = "PEYMENT".$req_id;
	    if($this->update($where,$date)){
	        // sms_to_managment
            $where_req['req_id'] = $req_id ;
            $data_req['req_driverid'] = $driverid ;
            $data_req['req_accept_suggestion'] =  date('Y-m-d H:i:s', time());
            $data_req['req_status'] =  "2";
            $this->sendSmd_cmp_id($req_id, "T-".$req_id , 1);
            $this->send_sms_by_id($driverid,"T-".$req_id , 2);
            if($this->requests_model->update($where_req,$data_req)){
                return TRUE ;
            }else{
                return FALSE ;
            }
        }else{
	        return FALSE ;
        }
    }//cancell_suggestion_by_driver
    function get_driver_barnameh($driverid)
    {
        date_default_timezone_set('Asia/Tehran');
        $where['bf_driverid'] = $driverid ;
        $where['bf_status'] = "1" ;
        $data = $this->get("bf_id , bf_reqid , bf_date" , $where);
        if(empty($data)){
            return FALSE;
        }else{
            $date_a = strtotime($data[0]->bf_date);
            $date_b = strtotime(date("Y-m-d H:i:s"));
            $interval = $date_b - $date_a;
            if($interval < 900){
                return $data[0]->bf_reqid;
            }else{
                $where_bf['bf_id'] = $data[0]->bf_id;
                $date_bf['bf_cancell_time'] = date('Y-m-d H:i:s', time());
                $date_bf['bf_status'] = "3";//cancell_by_system
                $this->update($where,$date_bf);
                return "0";
            }
        }
    }//get_driver_barnameh
    function check_barname_requests($reg_id)
    {
        date_default_timezone_set('Asia/Tehran');

        $this->db->select("*");
        $where['bf_reqid'] = $reg_id ;
        $bf_status= array('1', '2');
        $this->db->or_where_in('bf_status', $bf_status);
        $this->db->where($where);
        $data = $this->db->get('_barname_factor', NULL , NULL)->result();
        if(empty($data)){
            return "0";
        }else{
            $date_a = strtotime($data[0]->bf_date);
            $date_b = strtotime(date("Y-m-d H:i:s"));
            $interval = $date_b - $date_a;
            if($interval < 900){
                return $data;
            }else{
                $this->cancell_barname_by_system($reg_id);
                return "0";
            }

        }
    }//get_driver_barnameh
    function get_barnameh_dead_time($reg_id)
    {

        $this->load->model('log_model');

        date_default_timezone_set('Asia/Tehran');
        $where['bf_reqid'] = $reg_id ;
        $where['bf_status'] = "1" ;
        $data = $this->get("*" , $where);
        $interval = "0";
        if(!empty($data)){
            $date_a = strtotime($data[0]->bf_date);
            $date_b = strtotime(date("Y-m-d H:i:s"));
            $interval = $date_b - $date_a;

//            $data_log['_id']= "get_barnameh_dead_time" ;
//            $data_log['value1']= $interval ;
//            $data_log['value2']= "req_id=".$reg_id ;
//            $data_log['value3']= "has data" ;
//            $data_log['value4']= $date_a ;
//            $data_log['value5']= $date_b ;
//            $this->log_model->insert($data_log);

        }

//        $data_log['_id']= "get_barnameh_dead_time" ;
//        $data_log['value1']= $interval ;
//        $data_log['value2']= "req_id=".$reg_id ;
//        $data_log['value3']= "no data" ;
//        $this->log_model->insert($data_log);

        return $interval;

    }//get_driver_barnameh



    function cancell_barname_by_system($reg_id , $driverid = "0")
    {
        date_default_timezone_set('Asia/Tehran');
        $where_bf['bf_reqid'] = $reg_id;
        $where_bf['bf_status'] = "1";
        if($driverid != "0"){
            $where_bf['bf_driverid'] = $driverid;
        }
        $date_bf['bf_cancell_time'] = date('Y-m-d H:i:s', time());
        $date_bf['bf_status'] = "3";
        $this->update($where_bf,$date_bf);
    }//get_driver_barnameh

    function get_driver_mobile($id)
    {
        $where['d_id'] = $id;
        $select = "d_mobile";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
//        var_dump($result);
        if(empty($result)){
            return "چنین راننده ای یافت نشد";
        }else{
            return $result[0]->d_mobile;
        }
    }//cmp_drivers_count
    function send_sms_by_id($driverid , $code ,$type ){
        $mobile = $this->get_driver_mobile($driverid);
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverPayFactor");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage() . "mobile=>" . $mobile . "driverid=".$driverid;
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
        return TRUE ;
    }//send_sms
    function get_company_admin_mobile($req_id){
	    $where['req_id'] = $req_id;
        $select = "req_company";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();

	    $where_cmp['cmp_id'] =$result[0]->req_company;
        $select_cmp = "cmp_mobile";
        $this->db->select($select_cmp);
        $this->db->where($where_cmp);
        $result_cmp = $this->db->get('_company', NULL, NULL)->result();
        return $result_cmp[0]->cmp_mobile;
    }//get_company_admin_mobile
    function sendSmd_cmp_id($req_id , $code ,$type ){
        $mobile = $this->get_company_admin_mobile($req_id);
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverPayFactor");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
        return TRUE ;
    }//send_sms

    function sendSmd_cancell($req_id , $code ,$type ){
        $mobile = $this->get_company_admin_mobile($req_id);
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverCancelFreight");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
        return TRUE ;
    }//send_sms


    function get_driver_barname_factor($bf_id , $driverid , $offset , $limit){
        $where_req['bf_driverid'] =$driverid;
        $where_req['bf_id'] =$bf_id;
        $group_by = "bf_id";
        $order_by = "bf_id desc";
        $select = "*";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        return $this->db->get('_barname_factor', $limit, $offset)->result();
    }//get_active_request
    function get_active_barnameh($driverid)
    {
        $jsonData["barnameh"] = array();
        date_default_timezone_set('Asia/Tehran');
        $where['bf_driverid'] = $driverid ;
        $where['bf_status'] = "1" ;
        $data = $this->get("*" , $where);
            foreach ($data as $item) {
                $date_a = strtotime($item->bf_date);
                $date_b = strtotime(date("Y-m-d H:i:s"));
                $interval = $date_b - $date_a;
                if($interval < 900){
                    $row = array();
                    $row["bf_id"] = $item->bf_id;
                    $row["bf_price"] = $item->bf_price;
                    $row["bf_reqid"] = $item->bf_reqid;
                    $row["bf_driverid"] = $item->bf_driverid;
                    $row["bf_date_en"] = $item->bf_date;
                    $row["bf_date_fa"] = $this->date_convert($data[0]->bf_date);
                    $row["bf_status"] = $item->bf_status;
                    $row["bf_time_peyment"] = $item->bf_time_peyment;
                    $row["bf_peyment_date"] = $item->bf_peyment_date;
                    $row["bf_code"] = "B-".$item->bf_id;
                    $row["bf_code_req"] = "T-".$item->bf_reqid;
                    $row["bf_cancell_time"] = $item->bf_cancell_time;
                    $jsonData["barnameh"][] = $row;

                }else{
                    $where_bf['bf_id'] = $item->bf_id;
                    $date_bf['bf_cancell_time'] = date('Y-m-d H:i:s', time());
                    $date_bf['bf_status'] = "3";//cancell_by_system
                    $this->update($where,$date_bf);
                }
            }

        return $jsonData;
    }//get_active_barnameh
    function date_convert($miladi_date)
    {
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function
    function dargah_peyment($req_id){
        date_default_timezone_set('Asia/Tehran');
	    $where['bf_reqid'] = $req_id;
	    $data['bf_dargah'] = "1";
	    $data['bf_dargah_time'] = date('Y-m-d H:i:s', time());
	    return $this->update($where,$data);
    }//dargah_peyment

    function driver_in_peyment($req_id){

    }//driver_in_peyment


    function allow_peyment_driver($req_id){
        $this->load->model('main/requests_model');
        $this->load->model('log_model');

        // pardakht shode bashe
        $where_pardakht['bf_status'] = "2";
        $where_pardakht['bf_reqid'] = $req_id;
        $date_pardakht = $this->get("bf_id" , $where_pardakht);
        if(empty($date_pardakht)){
            // zamanesh tamom nashode bashe
            $dead_time = $this->get_barnameh_dead_time($req_id);
            if($dead_time > 900){
                return 2;// zamanesh tamom shode
            }else{
                // laghv nashode bashe ya tasasote rannade dige anjam nashode bashe
                $req_status = $this->requests_model->get_req_status($req_id);
                return 0;
            }
        }else{
            return 1;// parkhat shode
        }

    }//allow_peyment


    function allow_peyment_cancell($req_id){
        $this->load->model('main/requests_model');
        $this->load->model('log_model');

        // pardakht shode bashe
        $where_pardakht['bf_status'] = "2";
        $where_pardakht['bf_reqid'] = $req_id;
        $date_pardakht = $this->get("bf_id" , $where_pardakht);
        if(empty($date_pardakht)){
            // zamanesh tamom nashode bashe
            $dead_time = $this->get_barnameh_dead_time($req_id);
            if($dead_time > 900){
                return 0;// zamanesh tamom shode
            }else{
                $req_status = $this->requests_model->get_req_status($req_id);
                if($req_status == "1"){
                    if($dead_time == "0"){
                        return 0 ;
                    }else{
                        return 1 ;
                    }
                }else{
                    return 1 ;
                }
            }
        }else{
            $data_log['_id']= "0" ;
            $data_log['value1']= "pardakht shode" ;
            $this->log_model->insert($data_log);
            return 1;// parkhat shode
        }

    }//allow_peyment


    function allow_peyment($req_id){
        $this->load->model('main/requests_model');
        $this->load->model('log_model');

        // pardakht shode bashe
        $where_pardakht['bf_status'] = "2";
        $where_pardakht['bf_reqid'] = $req_id;
        $date_pardakht = $this->get("bf_id" , $where_pardakht);
        if(empty($date_pardakht)){
            // zamanesh tamom nashode bashe
            $dead_time = $this->get_barnameh_dead_time($req_id);
            if($dead_time > 900){
                return 0;// zamanesh tamom shode
            }else{
                // laghv nashode bashe ya tasasote rannade dige anjam nashode bashe
                $req_status = $this->requests_model->get_req_status($req_id);

                $data_log['_id']= "0" ;
                $data_log['value1']= "allow_peyment req_status= " . $req_status;
                $this->log_model->insert($data_log);
                return 4;
            }
        }else{
            $data_log['_id']= "0" ;
            $data_log['value1']= "pardakht shode" ;
            $this->log_model->insert($data_log);
            return 1;// parkhat shode
        }

    }//allow_peyment


    function allow_cancell_trip($req_id){
        $this->load->model('main/requests_model');
        // pardakht shode bashe
        $where_pardakht['bf_status'] = "2";
        $date_pardakht = $this->get("bf_id" , $where_pardakht);
        if(empty($date_pardakht)){
                $req_status = $this->requests_model->get_req_status($req_id);
                if($req_status == "1"){
                    return 0 ;
                }else{
                    return 2;// laghv shode ya tavasote rannade dige anjam shode
                }
        }else{
            return 1;// parkhat shode
        }

    }//allow_peyment


    function get_active_barnameh_count($driverid)
    {
        $count = 0 ;
        $jsonData["barnameh"] = array();
        date_default_timezone_set('Asia/Tehran');
        $where['bf_driverid'] = $driverid ;
        $where['bf_status'] = "1" ;
        $data = $this->get("bf_id , bf_date , " , $where);
        foreach ($data as $item) {
            $date_a = strtotime($item->bf_date);
            $date_b = strtotime(date("Y-m-d H:i:s"));
            $interval = $date_b - $date_a;
            if($interval < 900){
                $count ++ ;
            }else{
                $where_bf['bf_id'] = $item->bf_id;
                $date_bf['bf_cancell_time'] = date('Y-m-d H:i:s', time());
                $date_bf['bf_status'] = "3";//cancell_by_system
                $this->update($where,$date_bf);
            }
        }

        return $count;
    }//get_active_barnameh




}//end of class