<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Requests_model extends CI_Model {

    function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL, $or_like = NULL) {
    if ($select != NULL)
      $this->db->select($select);
    if ($where != NULL)
      $this->db->where($where);
    if ($order_by != NULL)
      $this->db->order_by($order_by);
    if ($group_by != NULL)
      $this->db->group_by($group_by);
    if ($or_like != NULL)
      $this->db->or_like($or_like);
    return $this->db->get('_requests', $limit, $offset)->result();

  } // get
    function get_join_user_experts ($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL, $or_like = NULL) {
    if ($select != NULL)
      $this->db->select($select);
    if ($where != NULL)
      $this->db->where($where);
    if ($order_by != NULL)
      $this->db->order_by($order_by);
    if ($group_by != NULL)
      $this->db->group_by($group_by);
    if ($or_like != NULL)
      $this->db->or_like($or_like);

      $this->db->join('_users', '_users.user_id=_requests.req_userid', 'left');
      $this->db->join('_experts', '_experts.ex_id=_requests.req_experts_id', 'left');
      $this->db->join('_category', '_category.cat_id=_requests.req_category', 'left');

      return $this->db->get('_requests', $limit, $offset)->result();

  } // get get_join_user_experts
    function update($where, $data) {
    $this->db->where($where);
    if ($this->db->update("_requests", $data))
      return TRUE;
    else
      return FALSE;
  } // update
    function req_online_pay($usrp_reg_id , $usrp_id) {
    $where['req_id'] = $usrp_reg_id ;
    $data['req_online_pay']= $usrp_id;
    $this->db->where($where);
    if ($this->db->update("_requests", $data))
      return TRUE;
    else
      return FALSE;
  } // update
    function insert($data) {
    if ($this->db->insert("_requests", $data))
      return $this->db->insert_id();
    else
      return FALSE;
  } // insert
    function delete($where) {
    $this->db->where($where);
    if ($this->db->delete("_requests"))
      return TRUE;
    else
      return FALSE;
  } // delete
    function valid_accept_req($req_id) {
    $where['req_id'] = $req_id ;
    $where['req_cancell'] = '0' ;
    $where['req_experts_id'] = '0';
    $this->db->select("req_id");
    $this->db->where($where);
    $data = $this->db->get('_requests')->result();
    if(empty($data)){
      return false;
    }else{
      return true ;
    }
  }// end of valid_accept_req



   function valid_accept_req_status($req_id) {
    $where['req_id'] = $req_id ;
    $where['req_cancell'] = '0' ;
    $this->db->select("req_experts_id");
    $this->db->where($where);
    $data = $this->db->get('_requests')->result();
    if(empty($data)){
      return "-1";
    }else{
      return $data[0]->req_experts_id;
    }
  }// end of valid_accept_req

    function get_bar_price($req_id){
        $where['req_id'] = $req_id ;
        $this->db->select("req_bar_price_driver");
        $this->db->where($where);
        $data = $this->db->get('_requests')->result();
        if(empty($data)){
            return "0";
        }else{
            return $data[0]->req_bar_price_driver;
        }
    }


    function get_company_id($req_id){
        $where['req_id'] = $req_id ;
        $this->db->select("req_company");
        $this->db->where($where);
        $data = $this->db->get('_requests')->result();
        if(empty($data)){
            return "0";
        }else{
            return $data[0]->req_company;
        }
    }




    function get_req_status($req_id)
    {
        $where['req_id'] = $req_id;
        $select = "req_status";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return $result[0]->req_status;
        }
    }//get_req_status
    function bar_count()
    {
        $select = "req_id";
        $this->db->select($select);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function cmp_bar_count($cmp_id)
    {
        $where['req_company'] = $cmp_id;
        $select = "req_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function bar_count_finished()
    {
        $where['req_status'] = "6";
        $select = "req_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function cmp_bar_count_finished($cmp_id)
    {
        $where['req_company'] = $cmp_id;
        $where['req_status'] = "6";
        $select = "req_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function bar_count_indo()
    {
        $select = "req_id";
        $where_special= array('1', '2' , '3','4','5');
        $this->db->where_in('req_status', $where_special);
        $this->db->select($select);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function cmp_bar_count_indo($cmp_id)
    {
        $where['req_company'] = $cmp_id;
        $select = "req_id";
        $where_special= array('1', '2' , '3','4','5');
        $this->db->where_in('req_status', $where_special);
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count
    function get_driver_req($driverid)
    {
        $where['req_driverid'] = $driverid;
//        $where['req_status !='] = "0";
        $where_special= array('1', '2' , '3','4','5');
        $this->db->or_where_in('req_status', $where_special);
        $select = "req_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return $result[0]->req_id;
        }
    }//cmp_drivers_count

    function get_driver_location($driverid){
        $where_req['d_id'] = $driverid;
        $select = "d_lat , d_lng , d_device";
        $this->db->select($select);
        $this->db->where($where_req);
        return $this->db->get('_drivers', NULL, NULL)->result();
    }//get_driver_location


    function get_active_request($driverid , $driverlat , $driverlng , $offset , $limit){

//        $res = $this->get_driver_location($driverid);
//        $driverlat = $res[0]->d_lat;
//        $driverlng = $res[0]->d_lng;
//        $device = $res[0]->d_device;

//        $where_req['req_bar_device'] = $device;
        $where_req['req_status'] = "1";
//        $where_req['req_send_all'] = "1";
        $group_by = "req_id";
        $order_by = "req_date desc";
        $select = " * ,( 3959 * acos( cos( radians('$driverlat') ) * cos( radians(req_lat1) )  * cos( radians(req_lng1) - radians('$driverlng')) + sin(radians('$driverlat')) * sin( radians(req_lat1)))) * 1000 AS d_distance ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        return $this->db->get('_requests', $limit, $offset)->result();
    }//get_active_request

    function get_active_request_all($driverid , $driverlat , $driverlng , $offset , $limit){

        $res = $this->get_driver_location($driverid);
//        $driverlat = $res[0]->d_lat;
//        $driverlng = $res[0]->d_lng;
        $device = $res[0]->d_device;

        $where_req['req_send_all'] = "1";
        $where_req['req_status'] = "1";
        $group_by = "req_id";
        $order_by = "req_date desc";
        $select = " * ,( 3959 * acos( cos( radians('$driverlat') ) * cos( radians(req_lat1) )  * cos( radians(req_lng1) - radians('$driverlng')) + sin(radians('$driverlat')) * sin( radians(req_lat1)))) * 1000 AS d_distance ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        return $this->db->get('_requests', $limit, $offset)->result();
    }//get_active_request


    function get_finished_request($driverid , $driverlat , $driverlng , $offset , $limit){



        $res = $this->get_driver_location($driverid);
        $driverlat = $res[0]->d_lat;
        $driverlng = $res[0]->d_lng;

        $where_req['req_driverid'] = $driverid;
        $where_req['req_status'] = "6";
        $group_by = "req_id";
        $order_by = "req_date desc";
        $select = " * ,( 3959 * acos( cos( radians('$driverlat') ) * cos( radians(req_lat1) )  * cos( radians(req_lng1) - radians('$driverlng')) + sin(radians('$driverlat')) * sin( radians(req_lat1)))) * 1000 AS req_distance ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        return $this->db->get('_requests', $limit, $offset)->result();
    }//get_active_request


    function get_accept_request($driverid , $driverlat , $driverlng , $offset , $limit){



        $res = $this->get_driver_location($driverid);
        $driverlat = $res[0]->d_lat;
        $driverlng = $res[0]->d_lng;

        $where_req['req_driverid'] = $driverid;
        $where_req['req_status !='] = "0";
        $group_by = "req_id";
        $order_by = "req_date desc";
        $select = " * ,( 3959 * acos( cos( radians('$driverlat') ) * cos( radians(req_lat1) )  * cos( radians(req_lng1) - radians('$driverlng')) + sin(radians('$driverlat')) * sin( radians(req_lat1)))) * 1000 AS req_distance ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        return $this->db->get('_requests', $limit, $offset)->result();
    }//get_active_request
    function get_suggestion_driver($driverid , $driverlat , $driverlng , $offset , $limit){

        $res = $this->get_driver_location($driverid);
        $driverlat = $res[0]->d_lat;
        $driverlng = $res[0]->d_lng;

        $where_req['req_status !='] = "0";
        $where_req['_driver_suggestion.ds_driverid'] = $driverid;
        $group_by = "req_id";
        $order_by = "req_date desc";
        $select = " *  ,( 3959 * acos( cos( radians('$driverlat') ) * cos( radians(req_lat1) )  * cos( radians(req_lng1) - radians('$driverlng')) + sin(radians('$driverlat')) * sin( radians(req_lat1)))) * 1000 AS req_distance ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        $this->db->join('_driver_suggestion', '_driver_suggestion.ds_reqid=_requests.req_id', 'left');
        return $this->db->get('_requests', $limit, $offset)->result();
    }//get_suggestion_driver
    function get_req_code($req_id){
        $where_req['req_id'] = $req_id;
        $select = "req_code";
        $this->db->select($select);
        $this->db->where($where_req);
        $data_out =  $this->db->get('_requests', NULL, NULL)->result();
        if(empty($data_out)){
            return "یافت نشد";
        }else{
            return $data_out[0]->req_code;
        }
    }//get_suggestion_driver
    function get_cmp_id($req_id){
        $where_req['req_id'] = $req_id;
        $select = "req_company";
        $this->db->select($select);
        $this->db->where($where_req);
        $data_out =  $this->db->get('_requests', NULL, NULL)->result();
        if(empty($data_out)){
            return "یافت نشد";
        }else{
            return $data_out[0]->req_company;
        }
    }//get_suggestion_driver
    function get_barname_price($req_id){
        $where_req['req_id'] = $req_id;
        $select = "req_barname_price";
        $this->db->select($select);
        $this->db->where($where_req);
        $data_out =  $this->db->get('_requests', NULL, NULL)->result();
        return $data_out[0]->req_barname_price;
    }//get_suggestion_driver


    function get_online_req_driver_new($driverid , $req_id ){

        $where_special= array('1', '2' , '3','4','5');
        $where_req['req_driverid'] = $driverid;
        $where_req['req_id'] = $req_id;
        $group_by = "req_id";
        $order_by = "req_date";
        $select = " * ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->where_in('req_status', $where_special);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        $this->db->join('_driver_suggestion', '_driver_suggestion.ds_reqid=_requests.req_id', 'left');
        return $this->db->get('_requests', NULL, NULL)->result();
    }//get_suggestion_driver

    function get_online_req_driver($driverid ){

        $where_special= array('1', '2' , '3','4','5');
        $where_req['req_driverid'] = $driverid;
        $group_by = "req_id";
        $order_by = "req_date";
        $select = " * ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->where_in('req_status', $where_special);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        $this->db->join('_driver_suggestion', '_driver_suggestion.ds_reqid=_requests.req_id', 'left');
        return $this->db->get('_requests', NULL, NULL)->result();
    }//get_suggestion_driver



    function get_req_detail($driverid , $req_id ){
        $where_req['req_status !='] = "0";
        $where_req['req_id'] = $req_id;
        $group_by = "req_id";
        $order_by = "req_date";
        $select = " * ";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        $this->db->join('_driver_suggestion', '_driver_suggestion.ds_reqid=_requests.req_id', 'left');
        return $this->db->get('_requests', NULL, NULL)->result();
    }//get_suggestion_driver
    function trip_change_status($req_id , $req_status , $driverid="0")
    {
        date_default_timezone_set('Asia/Tehran');
        $this->load->model('barname_model');
        $this->load->model('setting_app_model');
        $this->load->model('company_transaction_model');
//        $this->load->model('travelcompany/drivers_model');



        $time = date('Y-m-d H:i:s', time());
        if($req_status == "2"){ // be mabdah residam
            $data['req_time1'] = $time ;
            $driver_comision = $this->setting_app_model->get_driver_comision();
            $barname_price = $this->barname_model->get_barname_price($req_id , $driverid);
            $komision = (($barname_price*$driver_comision) / 100);
            $cmp_peyment = $barname_price - $komision ;
            $customer_id_company = $this->get_cmp_customer_id($req_id);

            $company_id = $this->get_company_id($req_id);
            $data_cmpt['cmpt_kind']="2";
            $data_cmpt['cmpt_price']=$komision;
            $data_cmpt['cmpt_req_id']=$req_id;
            $data_cmpt['cmpt_cmp_id']=$company_id;
            $this->company_transaction_model->insert($data_cmpt);

//            echo $barname_price;
//            echo "<br>";
//            echo $customer_id_company;
//            echo "<br>";
//            echo $komision;
//            echo "<br>";
//            echo $cmp_peyment;

            if($this->sharingtransfer("tdriver/barname",$barname_price,"tdriver/transport_wage",$customer_id_company,$komision,$cmp_peyment)){


            }



        }
        else if($req_status == "3"){// HARKAT BE SAMTE MAGHSAD
            $data['req_time2'] = $time ;
        }
        else if($req_status == "5"){// etmam safar
            // kasb daramad
            $bar_price = $this->get_bar_price($req_id);
            $this->insert_to_table($driverid , $bar_price,"0","1","6"," INCOME ".$req_id,"","");

        }
        $req_status += 1 ;
        $where['req_id']=$req_id;
        $data['req_status'] = $req_status ;
        if($this->update($where,$data)){
            return $req_status;
        }else{
            return "0";
        }
    }//trip_change_status


    function insert_drivers_transaction($data)
    {
        if($this->db->insert('_drivers_transaction', $data))
            return $this->db->insert_id();
        else
            return FALSE;
    }

    function insert_to_table($driverid , $price ,$new_credit ,$status ,$kind , $code1 , $code2 , $code3){
        $data['dt_price'] = $price;
        $data['dt_new_credit'] = $new_credit;
        $data['dt_status'] = $status;
        $data['dt_code1'] = $code1;
        $data['dt_code2'] = $code2;
        $data['dt_code3'] = $code3;
        $data['dt_kind'] = $kind;
        $data['dt_driverid'] = $driverid;

        if($this->insert_drivers_transaction($data)){
            return TRUE;
        }else{
            return FALSE;
        }
    }//insert_to_table


    function get_cmp_customer_id($req_id){
        $this->load->model('travelcompany/company_model');
      $cmp_id = $this->get_cmp_id($req_id);
      $cmp_customer_id = $this->company_model->get_customer_id($cmp_id);
      return $cmp_customer_id ;
    }
    function sharingtransfer($customer_id="tdriver/09120917777" , $amount=1000 , $customer_id1="tdriver/09120917577" ,
                             $customer_id2="tdriver/09120917576" , $amount1=700 , $amount2=300){


        $amount = $amount * 10 ;
        $amount1 = $amount1 * 10 ;
        $amount2 = $amount2 * 10 ;


        $Authorization = $this->AbrlineToken();

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/sharingtransfer",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => "{\n\t\"sender_customer_id\":\"$customer_id\",\n\t\"receiver_customer_ids\":[\"$customer_id1\",\"$customer_id2\"],\n\t\"amount\":$amount,\n\t\"type\":\"transfer\",\n\t\"divide_type\":\"fixed\",\n\t\"divide_amounts\":[$amount1,$amount2],\n\t\"sender_comment\":\"purchase subscription\"\n}",
            CURLOPT_POST => true,
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Content-Type: application/json",
                "Postman-Token: 732dc300-8720-42e5-a811-0f2255878c0f",
                "cache-control: no-cache"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return false ;
        } else {
            $result_json = json_decode($response);
            $status = $result_json->status->description;
            if($status == "success"){
                return true ;
            }
            else{
                return false ;
            }
        }

    }//userwithdraw
    function AbrlineToken(){
        $URL = "https://abrlife.com/api/v2/business/login";
        $data = array('username' => 'tdriver', 'password' => '!@#tdriver.admin');

        $options = array(
            'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data)
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($URL, false, $context);
        if ($result === FALSE) {

            return 0;
        }else{
            $result_json = json_decode($result);
            $code = $result_json->status->code ;
            $description = $result_json->status->description ;
            if($code == 200 && $description == 'success'){
                $id = $result_json->data->business->_id ;
                $token = $result_json->data->token ;
                return $token;
            }else{
                $data = $result_json->data ;
                $out['status'] = "OK";
                $out['message'] = $data;
                return 0;
            }
        }
    }//Abrlife_login


    function cancell_trip($req_id){
        date_default_timezone_set('Asia/Tehran');
        $where['req_id'] = $req_id;
        $date['req_status'] = "0";
        $date['req_time1'] = date('Y-m-d H:i:s', time());

        $where_barname['bf_reqid'] = $req_id;
        $data_barname['bf_status'] = "0";
        if($this->update_barname($where_barname , $data_barname)){
            if($this->update($where ,$date )){
                return TRUE ;
            }else{
                return False ;
            }
        }else{
            return False ;
        }

    }//cancell_trip


    function update_barname($where, $data)
    {
        $this->db->where($where);
        if($this->db->update('_barname_factor ', $data))
            return TRUE;
        else
            return FALSE;
    }//update


    function get_req_unread($driverid,$driverlat ,$driverlng){
         $where['d_id'] = $driverid;
         $select = "d_active_req_visit";
         $this->db->select($select);
         $this->db->where($where);
         $data =  $this->db->get('_drivers', NULL, NULL)->result();
         if(!empty($data)){
             $last_time = $data[0]->d_active_req_visit;
             $where_req['req_status'] = "1";
             $where_req['req_date >='] = $last_time;
             $group_by = "req_id";
             $order_by = "req_date desc";
             $select = " * ,( 3959 * acos( cos( radians('$driverlat') ) * cos( radians(req_lat1) )  * cos( radians(req_lng1) - radians('$driverlng')) + sin(radians('$driverlat')) * sin( radians(req_lat1)))) * 1000 AS d_distance ";
             $this->db->select($select);
             $this->db->where($where_req);
             $this->db->order_by($order_by);
             $this->db->group_by($group_by);
             $data_req =  $this->db->get('_requests', NULL, NULL)->result();
             return sizeof($data_req);
         }else{
             return 0 ;
         }
    }//get_req_unread


}// end of Requests_model
