<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Taxi_model extends CI_Model {

  function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL, $or_like = NULL) {
    if ($select != NULL)
      $this->db->select($select);
    if ($where != NULL)
      $this->db->where($where);
    if ($order_by != NULL)
      $this->db->order_by($order_by);

    if ($group_by != NULL)
      $this->db->group_by($group_by);

    if ($or_like != NULL)
      $this->db->or_like($or_like);

    return $this->db->get('taxi', $limit, $offset)->result();
  }

  function update($where, $data) {
    $this->db->where($where);
    if ($this->db->update("taxi", $data))
      return TRUE;
    else
      return FALSE;
  }


  function update_bank($where, $data) {
    $this->db->where($where);
    if ($this->db->update("driver_bank", $data))
      return TRUE;
    else
      return FALSE;
  }


  function insert($data) {
    if ($this->db->insert("taxi", $data))
      return TRUE;
    else
      return FALSE;
  }

  function delete($where) {
    $this->db->where($where);
    if ($this->db->delete("taxi"))
      return TRUE;
    else
      return FALSE;
  }


  function get_service_kind($driverid) {
      $sql = "SELECT taxi_kind 	FROM taxi WHERE id = '$driverid' ";
      $out = $this->db->query($sql)->result() ;
     if(sizeof ($out) > 0 )
       return $out[0]->taxi_kind;
    else
      return "0";
  }


  function near_by($lat, $long, $service_radius, $taxitel) {
    // $sql1 = "SELECT * from requests ";

    $sql3 = "SELECT * , users.usr_mobile AS mobile , destinitions.address AS dess , requests.address AS address , requests.id AS id , ( 3959 * acos( cos( radians('$lat') ) * cos( radians( requests.lat1 ) )  * cos( radians(requests.lng1) - radians('$long')) + sin(radians('$lat')) * sin( radians(requests.lat1)))) AS distance
			FROM requests
			INNER JOIN destinitions ON requests.id = destinitions.father_id
			INNER JOIN trip_online ON requests.id = trip_online.req_id
			INNER JOIN users ON users.usr_id = requests.userid
		    WHERE taxitel1='$taxitel' AND  trip_online.cancell ='0' AND trip_online.finished ='0' AND trip_online.finished ='0' AND trip_online.driverid = '0' AND date >= date_sub(NOW(), interval 80 minute)
			GROUP BY requests.id
		    HAVING distance <= '$service_radius'
			ORDER BY requests.id DESC";

    $sql2 = 'SELECT date
			FROM requests
		    WHERE  date >= date_sub(NOW(), interval 10 hour)  ';

    // $sql = "SELECT * , ROUND(6371 * acos(cos(radians('.$lat.')) * cos(radians(lat1)) * cos(radians(lng1) - radians('.$long.')) + sin(radians('.$lat.')) * sin(radians(lat1)))) * 1000 as distance from requests HAVING distance <= '.$service_radius.' and status = 0  order by date desc";
    // echo $sql ;
    return $this->db->query($sql3)->result();
  }

}