<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Drivers_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);

		if($where != NULL)
			$this->db->where($where);

		if($order_by != NULL)
			$this->db->order_by($order_by);

		if($group_by != NULL)
			$this->db->group_by($group_by);


		return $this->db->get('_drivers', $limit, $offset)->result();
	}//get


    function get_cmp($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
    {
        if($select != NULL)
            $this->db->select($select);

        if($where != NULL)
            $this->db->where($where);

        if($order_by != NULL)
            $this->db->order_by($order_by);

        if($group_by != NULL)
            $this->db->group_by($group_by);


        return $this->db->get('_company', $limit, $offset)->result();
    }


    function search($select = NULL, $where = NULL, $order_by = NULL, $group_by = NULL , $or_like = NULL)
    {
        if($select != NULL)
            $this->db->select($select);

        if($where != NULL)
            $this->db->where($where);

        if($order_by != NULL)
            $this->db->order_by($order_by);

        if($group_by != NULL)
            $this->db->group_by($group_by);

        if($or_like != NULL)
            $this->db->or_like($or_like);


        return $this->db->get('_drivers')->result();
    }//search
	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_drivers', $data))
			return TRUE;
		else
			return FALSE;
	}//update
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_drivers'))
			return TRUE;
		else
			return FALSE;
	}//delete
	function insert($data)
	{
		if($this->db->insert('_drivers', $data))
            return $this->db->insert_id();
		else
			return FALSE;
	}//insert
    function drivers_count()
    {
        $select = "d_id";
        $this->db->select($select);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count


    function get_company_name_by_driverid($driver_id){
        $where['d_id'] = $driver_id;
        $select = "d_company";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            $d_company =  $result[0]->d_company;
            if ($d_company == "1000") {
                return "اپلیکیشن تی درایور";
            } else{
                $where_cmp['cmp_id'] = $d_company;
                $data_cmp = $this->get_cmp("cmp_name", $where_cmp);
                if (!empty($data_cmp)) {
                    return $data_cmp[0]->cmp_name;
                } else {
                    return "یافت نشد";
                }
            }
        }


    }//get_company_name_by_driverid

    function cmp_drivers_count($cmp_id)
    {
        $where['d_company'] = $cmp_id;
        $select = "d_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return sizeof($result);
        }
    }//cmp_drivers_count


    function get_drivers_status($driverid)
    {
        $where['d_id'] = $driverid;
        $select = "d_status";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return FALSE;
        }else{
            return $result[0]->d_status;
        }
    }//cmp_drivers_count


    function get_driver_credit($driverid)
    {
        $where['d_id'] = $driverid;
        $select = "d_credit";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return FALSE;
        }else{
            return $result[0]->d_credit;
        }
    }//cmp_drivers_count
    function get_driver_credit_gift($driverid)
    {
        $where['d_id'] = $driverid;
        $select = "d_gift_credit";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return FALSE;
        }else{
            return $result[0]->d_gift_credit;
        }
    }//cmp_drivers_count
    function get_driver_customer_id($driverid)
    {
        $where['d_id'] = $driverid;
        $select = "d_customer_id";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return FALSE;
        }else{
            return $result[0]->d_customer_id;
        }
    }//cmp_drivers_count
    function get_driver_name($id)
    {
        $where['d_id'] = $id;
        $select = "d_name , d_family";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return "چنین راننده ای یافت نشد";
        }else{
            return $result[0]->d_name . " " . $result[0]->d_family;
        }
    }//cmp_drivers_count
    function get_driver_mobile($id)
    {
        $where['d_id'] = $id;
        $select = "d_mobile";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
//        var_dump($result);
        if(empty($result)){
            return "چنین راننده ای یافت نشد";
        }else{
            return $result[0]->d_mobile;
        }
    }//cmp_drivers_count
    function get_driver_firebase($id)
    {
        $where['d_id'] = $id;
        $select = "d_firebase_code";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return "0";
        }else{
            return $result[0]->d_firebase_code;
        }
    }//cmp_drivers_count
    function get_driver_status($id)
    {
        $where['d_id'] = $id;
        $select = "*";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        return $result;
    }//get_driver_status



    function submit_active_req_visit($driverid)
    {
        date_default_timezone_set('Asia/Tehran');
        $where['d_id'] = $driverid ;
        $data['d_active_req_visit'] = date('Y-m-d H:i:s', time());

        $this->update($where, $data);
    }//delete


    function submit_driver_information($driverid , $firebase_code , $driverlat ,$driverlng )
    {
        date_default_timezone_set('Asia/Tehran');

        $select = "*";
        $where['d_id'] = $driverid ;
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return $result;
        }else {
            $where_up['d_id'] = $driverid;
            $update_tb = false;
            if ($firebase_code != null && $firebase_code != "") {
                $update_tb = true;
                $data_up['d_firebase_code'] = $firebase_code;

            }
            if ($driverlat != "0" && $driverlat != "0.0" && $driverlat != "") {
                $update_tb = true;
                $data_up['d_lat'] = $driverlat;
                $data_up['d_lng'] = $driverlng;
                $data_up['d_last_update_location'] = date('Y-m-d H:i:s', time());
            }
            if ($update_tb) {
                $this->update($where_up, $data_up);
            }
            return $result;
        }

    }//delete
    function get_drivers_active($distance , $device , $all , $lat , $lng)
    {
        $where['d_status'] = "1";
        $data = $this->get('d_firebase_code' , $where);

        if($all == "1"){
//            $where_driver['d_device'] = $device;
//            $group_by = "d_id";
//            $order_by = "d_id desc";
//            $select = " d_id , d_firebase_code ,( 3959 * acos( cos( radians('$lat') ) * cos( radians(d_lat) )  * cos( radians(d_lng) - radians('$lng')) + sin(radians('$lat')) * sin( radians(d_lat)))) * 1000 AS distance ";
//            $this->db->select($select);
//            $this->db->where($where_driver);
//            $this->db->order_by($order_by);
//            $this->db->group_by($group_by);
//            return $this->db->get('_drivers', NULL, NULL)->result();

            $sql = "SELECT d_firebase_code  , d_id ,
            ( 3959 * acos( cos( radians('$lat') ) * cos( radians( d_lat) )  * cos( radians(d_lng) - radians('$lng')) + sin(radians('$lat')) * sin( radians(d_lat)))) * 1000 AS distance
             FROM _drivers
              GROUP BY d_id  
              HAVING distance < '$distance'
                ORDER BY d_id desc LIMIT 25
                 ";
            return $this->db->query($sql)->result();


        }else{
//            $where_driver['d_device'] = $device;//ok
//            $group_by = "d_id";
//            $order_by = "d_id desc";
//            $select = " d_firebase_code ,( 3959 * acos( cos( radians('$lat') ) * cos( radians(d_lat) )  * cos( radians(d_lng) - radians('$lng')) + sin(radians('$lat')) * sin( radians(d_lat)))) * 1000 AS distance ";
//            $this->db->select($select);
//            $this->db->having(" distance < '$distance'");
//            $this->db->where($where_driver);
////            $this->db->order_by($order_by);
//            $this->db->group_by($group_by);
//            return $this->db->get('_drivers', NULL, NULL)->result();

            $sql = "SELECT d_firebase_code  , d_id ,
            ( 3959 * acos( cos( radians('$lat') ) * cos( radians( d_lat) )  * cos( radians(d_lng) - radians('$lng')) + sin(radians('$lat')) * sin( radians(d_lat)))) * 1000 AS distance
             FROM _drivers
             WHERE d_device = '$device' 
              GROUP BY d_id  
              HAVING distance < '$distance'
                ORDER BY d_id desc LIMIT 25
                 ";
            return $this->db->query($sql)->result();


        }

    }//get_drivers_active
    function check_driver_mobile($mobile)
    {

        $where['d_mobile'] = $mobile;
        $select = "d_verify_code , d_status , d_id ";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return "A";
        }else{
            if($result[0]->d_verify_code != NULL){
                if($this->send_sms($mobile , $result[0]->d_verify_code , "1")){
                    return $result[0]->d_id ;
                }else{
                    return "B" ;
                }
            }
            else if($this->random_digit($mobile)){
                return $result[0]->d_id ;
            }else{
                return "B" ;
            }
        }
    }//check_driver_mobile
    function remove_sms_code($driverid){
        $where['d_id'] = $driverid;
        $data['d_verify_code'] = NULL;
        if($this->update($where,$data)){
            return TRUE ;
        }else{
            return FALSE ;
        }
    }//send_sms
    function random_digit($mobile){

        $random_numer = rand(1001, 9999);
        $where['d_mobile'] = $mobile;
        $data['d_verify_code'] = $random_numer;
        if($this->update($where ,$data)){
            if($this->send_sms($mobile , $random_numer , "1")){
                return TRUE ;
            }else{
                return FALSE;
            }
        }else{
            return FALSE;
        }

    }//random_digit
    function get_address($lat1 , $lng1 , $lat2 , $lng2)
    {
        $url = "https://maps.googleapis.com/maps/api/distancematrix/json?key=AIzaSyBelEhmWDmfkmCKJNkpmNFRdU7CV7OHUSo&origins=$lat1,$lng1&destinations=$lat2,$lng2&mode=driving&language=fa&sensor=false";
        $distance_time = @file_get_contents($url);
        $json = json_decode($distance_time);
        $status = $json->status;

        if($status=="OK"){
            $address = $json->destination_addresses[0];
            $address = str_replace('استان', '', $address);
            $address = str_replace('فارس', '', $address);
            $address = str_replace('تهران', '', $address);
            $address = str_replace('فارس', '', $address);
            $address = str_replace('ایران', '', $address);
            $address = str_replace('Tehran Province', '', $address);
            $address = str_replace('Tehran', '', $address);
            $address = str_replace('Unnamed Road', 'جاده بیرون شهر', $address);
            $address = str_replace('،', '', $address);
            $address = str_replace(',', '', $address);
            $jsonData['address'] = $address;
        }
        else{
            $jsonData['address'] = $status;
        }

        return $address ;
    }// end of get_address
    function send_sms($mobile , $code ,$type ){
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverVerify");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage();
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
        return TRUE ;
    }//send_sms
    function send_sms_by_id($driverid , $code ,$type ){
        $mobile = $this->get_driver_mobile($driverid);
        $api_key["apikey"] = "4A6372364C317056324C6877647A4338594C394B45673D3D";
        $this->load->library('sms/api', $api_key);
        try {
            $result = $this->api->VerifyLookup($mobile, $code, "", "", "tdriverVerify");
//         echo var_dump($result);
        } catch (ApiException $ex) {
            echo $ex->errorMessage() . "mobile=>" . $mobile . "driverid=".$driverid;
        } catch (HttpException $ex) {
            echo $ex->errorMessage();
        }
        return TRUE ;
    }//send_sms
    function send_to_drivers($kind , $title , $message , $driverid , $req_id) {

	    $firebase_code = $this->get_driver_firebase($driverid);

        $url = 'https://fcm.googleapis.com/fcm/send';
        $fields = array(
            'to' => $firebase_code,
            'priority' => 'high',
            'time_to_live' => 40,
            'data' => array(
                "title" => $title, //title
                "message" => $message, // message
                "kind" => $kind, // kind
                "req_id" => $req_id   // req_id
            )
        );
        $fields = json_encode($fields);
        $headers = array(
            'Authorization: key=' . "AAAA2qTcEDs:APA91bEOOQ0Y3UJQKjfYMOPH4inumJhQRIZBRJtzQiaaPARloJkeRzIIxFyMvjV0BNlOgauTsXCl9Ks2NwK224JdLDshaAlPNlAQJ415mPLqpURN-0_qhWtCxaGksEUXel_cor6kPMyq2QoFE1J005sljSOnWVePFw",
            'Content-Type: application/json'
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        $result = curl_exec($ch);
        curl_close($ch);
//        echo"<br>";
//        var_dump($result);


    }// end of send_to_drivers


}//end of class