<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Fav_ex_model extends CI_Model {
  function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL, $where_in = NULL, $or_like = NULL) {
    if ($select != NULL)
      $this->db->select($select);
    if ($where != NULL)
      $this->db->where($where);
    if ($order_by != NULL)
      $this->db->order_by($order_by);
    if ($group_by != NULL)
      $this->db->group_by($group_by);
    if ($where_in != NULL)
      $this->db->where_in($where_in);
    if ($or_like != NULL)
      $this->db->or_like($or_like);

    $this->db->join('_experts', '_experts.ex_id=_fav_ex.fe_ex_id', 'left');

    return $this->db->get('_fav_ex', $limit, $offset)->result();


  }// end of get

  function insert($data) {
    if ($this->db->insert('_fav_ex', $data))
      return TRUE;
    else
      return FALSE;
  }// end of insert

  function update($where, $data) {
    $this->db->where($where);
    if ($this->db->update('_fav_ex', $data))
      return TRUE;
    else
      return FALSE;
  }// end of update

  function delete($where) {
    $this->db->where($where);
    if ($this->db->delete('_fav_ex'))
      return TRUE;
    else
      return FALSE;
  }// end of delete


  function get_performer_active($lat, $lng, $catid, $distance) {


    $sql = "SELECT ex_lat , ex_lng , ex_id , ex_firebase_code , ( 3959 * acos( cos( radians('$lat') ) * cos( radians(ex_lat) )  * cos( radians(ex_lng) - radians('$lng')) + sin(radians('$lat')) * sin( radians(ex_lat)))) * 1000 AS distance
FROM _experts
WHERE ex_catid = '$catid' AND ex_app_status = '1'
HAVING distance < '$distance' ";

    return $this->db->query($sql)->result();
  }// end of get_count_category

  function find_main_cat($catid) {

  } // find_main_cat


  function get_performer_active_all_cat($lat, $lng, $catid, $distance) {

    $where['cat_id'] = $catid;
    $this->db->select("cat_subcat");
    $this->db->where($where);
    $data = $this->db->get('_category')->result();
    $main_cat =  $data[0]->cat_subcat;


    $sql = "SELECT ex_lat , ex_lng , ex_id , ex_firebase_code , ( 3959 * acos( cos( radians('$lat') ) * cos( radians(ex_lat) )  * cos( radians(ex_lng) - radians('$lng')) + sin(radians('$lat')) * sin( radians(ex_lat)))) * 1000 AS distance
FROM _experts
WHERE ex_main_cat = '$main_cat' AND ex_app_status = '1'
HAVING distance < '$distance' ";

    return $this->db->query($sql)->result();
  }// end of get_count_category



  function get_count_category($where) {
    $this->db->select('ex_id');
    $this->db->where($where);
    $data = $this->db->get('_experts')->result();
    return sizeof($data);
  }// end of get_count_category


  function get_count_experts($where) {
    $this->db->select('ex_id');
    $this->db->where($where);
    $this->db->join('_category', '_category.cat_id = _experts.ex_catid', 'left');
    $data = $this->db->get('_experts')->result();
    return sizeof($data);
  }// end of get_count_category


  function get_expert_name_by_id($where) {
    $this->db->select("ex_name , ex_family");
    $this->db->where($where);
    $data = $this->db->get('_experts')->result();
    return $data[0]->ex_name . " " . $data[0]->ex_family;
  }// end of get_user_name_by_id

  function get_expert_image_by_id($where) {
    $this->db->select("ex_image");
    $this->db->where($where);
    $data = $this->db->get('_experts')->result();
    return $data[0]->ex_image;
  }// end of get_info_by_id


  function get_expert_name_image_mobile_by_id($where) {
    $this->db->select("ex_name , ex_family ,  ex_image , ex_mobile");
    $this->db->where($where);
    $data = $this->db->get('_experts')->result();
    return $data;
  }// end of get_info_by_id

  function get_expert_catid_by_id($where) {
    $this->db->select("ex_catid");
    $this->db->where($where);
    $data = $this->db->get('_experts')->result();
    return $data[0]->ex_catid;
  }// end of get_expert_catid_by_id

  function get_expert_dis_to_location($ex_id, $lat, $lng) {
    $where['ex_id'] = $ex_id;
    $this->db->select("ex_lat , ex_lng");
    $this->db->where($where);
    $data = $this->db->get('_experts')->result();
    return $this->distance($data[0]->ex_lat, $data[0]->ex_lng, $lat, $lng);
  }// end of get_expert_catid_by_id

  function distance(
    $latitudeFrom, $longitudeFrom, $latitudeTo, $longitudeTo, $earthRadius = 6371000) {
    // convert from degrees to radians
    $latFrom = deg2rad($latitudeFrom);
    $lonFrom = deg2rad($longitudeFrom);
    $latTo = deg2rad($latitudeTo);
    $lonTo = deg2rad($longitudeTo);

    $lonDelta = $lonTo - $lonFrom;
    $a = pow(cos($latTo) * sin($lonDelta), 2) +
      pow(cos($latFrom) * sin($latTo) - sin($latFrom) * cos($latTo) * cos($lonDelta), 2);
    $b = sin($latFrom) * sin($latTo) + cos($latFrom) * cos($latTo) * cos($lonDelta);

    $angle = atan2(sqrt($a), $b);
    return $angle * $earthRadius;
  }//distance


  function increase_credit($ex_id, $credit) {
    $sql = "UPDATE _experts SET ex_credit= ex_credit + '$credit' WHERE ex_id= '$ex_id' ";
    if($this->db->query($sql)){
      $sql = "SELECT ex_credit From _experts  WHERE ex_id= '$ex_id' ";
      $result = $this->db->query($sql)->result();
      return $result[0]->ex_credit;
    }else{
      return FALSE;
    }
  }// end of increase_credit


  function decrease_credit($ex_id, $credit) {
    $sql = "UPDATE _experts SET ex_credit= ex_credit - '$credit' WHERE ex_id= '$ex_id' ";
    if($this->db->query($sql)){
      $sql = "SELECT ex_credit From _experts  WHERE ex_id= '$ex_id' ";
      $result = $this->db->query($sql)->result();
      return $result[0]->ex_credit;
    }else{
      return FALSE;
    }
  }// end of increase_credit


} // end of Update_model
