
<!DOCTYPE html>
<html>
<head>

    <title>Quick Start - Leaflet</title>

    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="shortcut icon" type="image/x-icon" href="docs/images/favicon.ico" />

    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.3.4/dist/leaflet.css" integrity="sha512-puBpdR0798OZvTTbP4A8Ix/l+A4dHDD0DGqYW6RQ+9jxkRFclaxxQb/SJAWZfWAkuyeQUytO7+7N4QKrDh+drA==" crossorigin=""/>
    <script src="https://unpkg.com/leaflet@1.3.4/dist/leaflet.js" integrity="sha512-nMMmRyTVoLYqjP9hrbed9S+FzjZHW5gY1TWCHA5ckwXZBadntCNs8kEqAWdrb9O7rxbCaA4lKTIWjDXZxflOcA==" crossorigin=""></script>



</head>
<body>



<div id="mapid" style="width: 100%; height: 500px;"></div>
<script>

    var map = L.map('mapid').setView(["<?php echo $location['latitude']; ?>", <?php echo $location['longitude']; ?>], 13);
    var marker1 = null ;
    var marker2 = null ;

    L.tileLayer('https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=pk.eyJ1IjoibW9oYW1hZGhhZGlkYWJpcmkiLCJhIjoiY2psY2FuNDJoMDI2dDNscGVzOGlzaHZqYSJ9.VCN3WNNM108jP1NcxuVj5w', {
        maxZoom: 18,
        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, ' +
        '<a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, ' +
        'Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
        id: 'mapbox.streets'
    }).addTo(map);

    // var LeafIcon = L.Icon.extend({
    //     options: {
    //         iconSize:     [95, 95],
    //         shadowSize:   [50, 64],
    //         iconAnchor:   [22, 94],
    //         shadowAnchor: [4, 62],
    //         popupAnchor:  [-3, -76]
    //     }
    // });
    //
    // var greenIcon = new LeafIcon({iconUrl: 'http://snapp1855.com/admin/app/template_inc/img/icon/wa_first.png'});
    // var marker1 = L.marker([35.6991980, 51.3889740], {icon: greenIcon}).addTo(map);
    // marker1.bindPopup("<b>نقطه شروع</b><br>محل بارگیری").openPopup();

    // var marker = L.marker([35.6891980, 51.3889740]).addTo(map);
    //
    // var draggable = new L.Draggable(marker);
    // draggable.enable();
    // marker.bindPopup("<b>نقطه شروع</b><br>محل بارگیری").openPopup();
    //
    // marker.on('click', function(e) {
    //     alert(e.latlng);
    // } );

    function onMapClick(e) {
        if(marker1 == null){
            marker1 = new L.marker(e.latlng, {draggable:'true'});
            marker1.on('dragend', function(event){
                var marker = event.target;
                var position = marker.getLatLng();
                marker.setLatLng(new L.LatLng(position.lat, position.lng),{draggable:'true'});
                map.panTo(new L.LatLng(position.lat, position.lng));
                $("#first_lat").val(position.lat);
                $("#first_lng").val(position.lng);
            });
            $("#first_lat").val(e.latlng.lat);
            $("#first_lng").val(e.latlng.lng);
            map.addLayer(marker1);
            marker1.bindPopup("<b>نقطه شروع</b><br>محل بارگیری").openPopup();
        }else if(marker2 == null){
            marker2 = new L.marker(e.latlng, {draggable:'true'});
            marker2.on('dragend', function(event){
                var marker = event.target;
                var position = marker.getLatLng();
                marker.setLatLng(new L.LatLng(position.lat, position.lng),{draggable:'true'});
                map.panTo(new L.LatLng(position.lat, position.lng))
                $("#second_lat").val(position.lat);
                $("#second_lng").val(position.lng);
            });
            $("#second_lat").val(e.latlng.lat);
            $("#second_lng").val(e.latlng.lng);
            map.addLayer(marker2);
            marker2.bindPopup("<b>نقطه پایان</b><br>محل تخلیه بار").openPopup();
        }

    };

    map.on('click', onMapClick);

</script>



</body>
</html>
